////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : goimage2
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//
//
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    goimage2.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////



#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 

#include <cstdlib> 
#include <ctime>  

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>
 


#define NOCOLUMNS 1


using namespace std;



int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[400];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,400,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,400,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
            
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(400,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(400,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}




int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////

int main()
{
  cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goIMAGE2' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";


//  srand((unsigned)time(0));
////////////////////////////////////////////////////////
timeval timv;
gettimeofday(&timv, NULL);

int randomini;
randomini=timv.tv_usec;
srand(randomini);
///////////////////////////////////////////////////////

  
  char *currentdirectory=getcwd(NULL, 0);
 


double uband,bband,vband,rband,iband,jband,hband,kband;
double xcoord, ycoord;
double sare;

int trektrek;
int skip;



  double read_column,col;
  double DM;

  int NOLINES,NODATALINES,NOCOL;
  
  int i,k,j,n,s,p,u,v,t,a,b,c,d,e,ii,h,r,ccm_on_off;
  int z,random_index1,random_index2;
  double x,y,xout,yout,aa,R_V;
  double segregation;
  double seg_index;

//  double xcenter,ycenter;



//  cluster.ini
double mass,r_c,r_t,r_a,r_a2,dd,FOV,WIDTH,HEIGHT,WIDTH_CCD,HEIGHT_CCD,secz;
double A_U2,A_B2,A_V2,A_R2,A_I2,A_J2,A_H2,A_K2;
double A_U3,A_B3,A_V3,A_R3,A_I3,A_J3,A_H3,A_K3;
double A_U4,A_B4,A_V4,A_R4,A_I4,A_J4,A_H4,A_K4;
//double K_U,K_B,K_V,K_R,K_I,K_J,K_H,K_K;
int VERBOSE;
int REBTYPE;
double PHOTERR;



chdir("ini.files");

ifstream clusterfile;
clusterfile.open("cluster.ini");

  if (clusterfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (clusterfile.peek()=='#') { clusterfile.ignore(300,'\n');}

clusterfile >> VERBOSE; clusterfile.ignore(300,'\n');
clusterfile >> mass; clusterfile.ignore(300,'\n');
clusterfile >> dd; clusterfile.ignore(300,'\n');
clusterfile >> FOV; clusterfile.ignore(300,'\n');
clusterfile >> WIDTH; clusterfile.ignore(300,'\n');
clusterfile >> HEIGHT; clusterfile.ignore(300,'\n');
clusterfile >> WIDTH_CCD; clusterfile.ignore(300,'\n');
clusterfile >> HEIGHT_CCD; clusterfile.ignore(300,'\n');
clusterfile >> ccm_on_off; clusterfile.ignore(300,'\n');
clusterfile >> R_V; clusterfile.ignore(300,'\n');
clusterfile >> secz; clusterfile.ignore(300,'\n');
clusterfile >> A_U2; clusterfile.ignore(300,'\n');
clusterfile >> A_B2; clusterfile.ignore(300,'\n');
clusterfile >> A_V2; clusterfile.ignore(300,'\n');
clusterfile >> A_R2; clusterfile.ignore(300,'\n');
clusterfile >> A_I2; clusterfile.ignore(300,'\n');
clusterfile >> A_J2; clusterfile.ignore(300,'\n');
clusterfile >> A_H2; clusterfile.ignore(300,'\n');
clusterfile >> A_K2; clusterfile.ignore(300,'\n');
/*
clusterfile >> K_U; clusterfile.ignore(300,'\n');
clusterfile >> K_B; clusterfile.ignore(300,'\n');
clusterfile >> K_V; clusterfile.ignore(300,'\n');
clusterfile >> K_R; clusterfile.ignore(300,'\n');
clusterfile >> K_I; clusterfile.ignore(300,'\n');
clusterfile >> K_J; clusterfile.ignore(300,'\n');
clusterfile >> K_H; clusterfile.ignore(300,'\n');
clusterfile >> K_K; clusterfile.ignore(300,'\n');
*/

clusterfile.ignore(300,'\n');

clusterfile.close();




ifstream setsfile;
setsfile.open("sets.ini");

  if (setsfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (setsfile.peek()=='#') { setsfile.ignore(300,'\n');}

int NOSETS;

setsfile >> NOSETS; setsfile.ignore(300,'\n');

setsfile.close();



if (VERBOSE==1)
{
cout << "Reading file cluster.ini...";

cout << "...done !"<<'\n';
}

chdir("..");

///// end cluster.ini

 

 //// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);
  
  //// add background 
  
 
  ofstream addbackground("add_field");
  
  addbackground<<"echo     "<<"\n";
  
  addbackground<<"echo Now copying *.list files to /data/saved.runs/list/ "<<"\n";
  addbackground<<"echo ... Please wait ... "<<"\n";
  
  addbackground<<"cp "<< currentdirectory<<"/data/star.sky/*.list "<< currentdirectory<<"/data/saved.runs/list/ "<<"\n";
  addbackground<<"\n";
  
  addbackground<<"echo ... done ! "<<"\n";
  addbackground<<"echo     "<<"\n";
  
  addbackground<<"echo Adding field.*.list... "<<"\n";
  addbackground<<"echo ... Please wait ... "<<"\n";
  
//  ofstream save("saveit"); ////
  
  
  
  ofstream runback("runfield");
  
  
  
/*
// read xcenter, ycenter from king.ini

chdir("ini.files");

if (VERBOSE==1)
{
cout << "Reading file king.ini...";
}
ifstream kingini;
kingini.open("king.ini");
if (kingini.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (kingini.peek()=='#') { kingini.ignore(300,'\n');}


kingini >> xcenter; kingini.ignore(300,'\n');
kingini >> ycenter; kingini.ignore(300,'\n');
kingini.ignore(300,'\n');

kingini.close();
if (VERBOSE==1)
{
cout << "...done !"<<'\n';
}

chdir("..");
*/


  ///read coordinates from 'king.out'

  chdir("data"); 

/*
if (VERBOSE==1)
{
  cout << "Reading file king.out...";
}
  int NOTOTALXY;

  NOTOTALXY=datalinescolumn("king.out",1);




/////////////////////////// 
ifstream filein2;
filein2.open("king.out");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}



filein2.close();

///////////////////////////////////////////////



if (VERBOSE==1)
{
cout << "...done !"<<'\n';
}

*/

/*
/////////////////////////////////////

if (VERBOSE==1)
{
cout << "Reading file ccm.filters...";
}

ifstream filterfile1;
filterfile1.open("ccm.filters");

  if (filterfile1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filterfile1.peek()=='#') { filterfile1.ignore(300,'\n');}

filterfile1 >> A_U3; filterfile1.ignore(300,'\n');
filterfile1 >> A_B3; filterfile1.ignore(300,'\n');
filterfile1 >> A_V3; filterfile1.ignore(300,'\n');
filterfile1 >> A_R3; filterfile1.ignore(300,'\n');
filterfile1 >> A_I3; filterfile1.ignore(300,'\n');
filterfile1 >> A_J3; filterfile1.ignore(300,'\n');
filterfile1 >> A_H3; filterfile1.ignore(300,'\n');
filterfile1 >> A_K3; filterfile1.ignore(300,'\n');

filterfile1.ignore(300,'\n');

filterfile1.close();

if (VERBOSE==1)
{
cout << "...done !"<<'\n';
cout <<'\n';
}

chdir(".."); 


///// EXTINCTION

double A_U,A_B,A_V,A_R,A_I,A_J,A_H,A_K;

if (ccm_on_off==0)
{
A_U=A_U2;
A_B=A_B2;
A_V=A_V2;
A_R=A_R2;
A_I=A_I2;
A_J=A_J2;
A_H=A_H2;
A_K=A_K2;

}


if (ccm_on_off==1)
{

A_U=A_U3;
A_B=A_B3;
A_V=A_V3;
A_R=A_R3;
A_I=A_I3;
A_J=A_J3;
A_H=A_H3;
A_K=A_K3;

}

*/

//////






// distance modulus

//  double apparent;

//  apparent=5.*log10(dd/10.);


//////////

/*
char pathtoskymaker[200];

if (VERBOSE==1)
{
cout << "Reading file skymaker.path...";
}
*/


chdir("ini.files");

/*
ifstream pathfile;
pathfile.open("skymaker.path");

  if (pathfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (pathfile.peek()=='#') { pathfile.ignore(300,'\n');}

pathfile >> pathtoskymaker;

pathfile.close();

if (VERBOSE==1)
{
cout << "...done !"<<"\n";
}

*/

//////////////////////////////////////////////////////////-->>>>>>>>
/*

/////////////////////////////////////////////////////////////////////////

//// STIFF interface
int NOPARAMTIFF;
int paraTIFF;


if (VERBOSE==1)
{
cout << "Reading file stiff.param...";
}

ifstream paramfileTIFF;
paramfileTIFF.open("stiff.param");

  if (paramfileTIFF.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (paramfileTIFF.peek()=='#') { paramfileTIFF.ignore(300,'\n');}
  
  
  
paramfileTIFF >> NOPARAMTIFF; paramfileTIFF.ignore(300,'\n');


char paramskymakerTIFF[NOPARAMTIFF][100];
char paramvalueTIFF[NOPARAMTIFF][100];

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
paramfileTIFF >> paramskymakerTIFF[paraTIFF];
paramfileTIFF >> paramvalueTIFF[paraTIFF];
paramfileTIFF.ignore(300,'\n');
}

paramfileTIFF.ignore(300,'\n');

paramfileTIFF.close();

if (VERBOSE==1)
{
cout << "...done !"<<"\n";
}


////  gnuplot.ini

if (VERBOSE==1)
{
cout << "Reading file gnuplot.ini...";
}

double POINTSIZE;
int NOIGNORE, HRONOFF,LABELSONOFF,AUTOSCALE,AUTOSCALEHR,FONTSIZE1,FONTSIZE2,COLOR1,COLOR2,COLOR3;
char PLOTFONT[40];
int FIELDONOFF;

ifstream gnuplot;
gnuplot.open("gnuplot.ini");

  if (gnuplot.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (gnuplot.peek()=='#') { gnuplot.ignore(300,'\n');}

gnuplot >> POINTSIZE; gnuplot.ignore(300,'\n');
gnuplot >> PLOTFONT; gnuplot.ignore(300,'\n');
gnuplot >> FONTSIZE1; gnuplot.ignore(300,'\n');
gnuplot >> FONTSIZE2; gnuplot.ignore(300,'\n');
gnuplot >> COLOR1; gnuplot.ignore(300,'\n');
gnuplot >> COLOR2; gnuplot.ignore(300,'\n');
gnuplot >> COLOR3; gnuplot.ignore(300,'\n');
gnuplot >> NOIGNORE; gnuplot.ignore(300,'\n');
gnuplot >> HRONOFF; gnuplot.ignore(300,'\n');
gnuplot >> LABELSONOFF; gnuplot.ignore(300,'\n');
gnuplot >> AUTOSCALEHR; gnuplot.ignore(300,'\n');
gnuplot >> AUTOSCALE; gnuplot.ignore(300,'\n');
gnuplot >> FIELDONOFF; gnuplot.ignore(300,'\n');
gnuplot.ignore(300,'\n');

gnuplot.close();

if (VERBOSE==1)
{
cout << "...done !"<<"\n";
}



//// mass labels

if (VERBOSE==1)
{
cout << "Reading file labels.dat...";
}

double X120,Y120,X85,Y85,X60,Y60,X40,Y40,X25,Y25,X20,Y20,X15,Y15,X12,Y12,X9,Y9,X7,Y7,X5,Y5,X4,Y4,X3,Y3,X2_5,Y2_5,X2,Y2,X1_7,Y1_7,X1_5,Y1_5,X1_25,Y1_25,X1_0,Y1_0,X0_9,Y0_9,X0_8,Y0_8;

ifstream labelsfile;
labelsfile.open("labels.dat");

  if (labelsfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (labelsfile.peek()=='#') { labelsfile.ignore(300,'\n');}

labelsfile >> X120;
labelsfile >> Y120; labelsfile.ignore(300,'\n');

labelsfile >> X85;
labelsfile >> Y85; labelsfile.ignore(300,'\n');

labelsfile >> X60;
labelsfile >> Y60; labelsfile.ignore(300,'\n');

labelsfile >> X40;
labelsfile >> Y40; labelsfile.ignore(300,'\n');

labelsfile >> X25;
labelsfile >> Y25; labelsfile.ignore(300,'\n');

labelsfile >> X20;
labelsfile >> Y20; labelsfile.ignore(300,'\n');

labelsfile >> X15;
labelsfile >> Y15; labelsfile.ignore(300,'\n');

labelsfile >> X12;
labelsfile >> Y12; labelsfile.ignore(300,'\n');

labelsfile >> X9;
labelsfile >> Y9; labelsfile.ignore(300,'\n');

labelsfile >> X7;
labelsfile >> Y7; labelsfile.ignore(300,'\n');

labelsfile >> X5;
labelsfile >> Y5; labelsfile.ignore(300,'\n');

labelsfile >> X4;
labelsfile >> Y4; labelsfile.ignore(300,'\n');

labelsfile >> X3;
labelsfile >> Y3; labelsfile.ignore(300,'\n');

labelsfile >> X2_5;
labelsfile >> Y2_5; labelsfile.ignore(300,'\n');

labelsfile >> X2;
labelsfile >> Y2; labelsfile.ignore(300,'\n');

labelsfile >> X1_7;
labelsfile >> Y1_7; labelsfile.ignore(300,'\n');

labelsfile >> X1_5;
labelsfile >> Y1_5; labelsfile.ignore(300,'\n');

labelsfile >> X1_25;
labelsfile >> Y1_25; labelsfile.ignore(300,'\n');

labelsfile >> X1_0;
labelsfile >> Y1_0; labelsfile.ignore(300,'\n');



labelsfile.ignore(300,'\n');

labelsfile.close();

if (VERBOSE==1)
{
cout << "...done !"<<"\n";
cout <<"\n";
}

*/


chdir("..");

/// /////////////////////////////////




// run i file
ofstream runoutfilei("runi");

  runoutfilei <<"##  "<< '\n';
  runoutfilei <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfilei <<"##  "<< '\n';
  runoutfilei <<"##  runi"<< '\n';
  runoutfilei <<"## " <<'\n';
  runoutfilei <<"echo     > counteri " <<'\n';
  runoutfilei <<"echo START : >> counteri " <<'\n';
  runoutfilei <<"date >> counteri " <<'\n';
  runoutfilei <<"echo     >> counteri " <<'\n';
//  runoutfilei <<"cd "<< pathtoskymaker<<'\n';

// run j file
ofstream runoutfilej("runj");

  runoutfilej <<"##  "<< '\n';
  runoutfilej <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfilej <<"##  "<< '\n';
  runoutfilej <<"##  runj"<< '\n';
  runoutfilej <<"## " <<'\n';
  runoutfilej <<"echo     > counterj " <<'\n';
  runoutfilej <<"echo START : >> counterj " <<'\n';
  runoutfilej <<"date >> counterj " <<'\n';
  runoutfilej <<"echo     >> counterj " <<'\n';

//  runoutfilej <<"cd "<< pathtoskymaker<<'\n';


// run hh file
ofstream runoutfileh("runh");

  runoutfileh <<"##  "<< '\n';
  runoutfileh <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfileh <<"##  "<< '\n';
  runoutfileh <<"##  runh"<< '\n';
  runoutfileh <<"## " <<'\n';
  runoutfileh <<"echo     > counterh " <<'\n';
  runoutfileh <<"echo START : >> counterh " <<'\n';
  runoutfileh <<"date >> counterh " <<'\n';
  runoutfileh <<"echo     >> counterh " <<'\n';

//  runoutfileh <<"cd "<< pathtoskymaker<<'\n';


// run k file
ofstream runoutfilek("runk");

  runoutfilek <<"##  "<< '\n';
  runoutfilek <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfilek <<"##  "<< '\n';
  runoutfilek <<"##  runk"<< '\n';
  runoutfilek <<"## " <<'\n';
  runoutfilek <<"echo     > counterk " <<'\n';
  runoutfilek <<"echo START : >> counterk " <<'\n';
  runoutfilek <<"date >> counterk " <<'\n';
  runoutfilek <<"echo     >> counterk " <<'\n';

//  runoutfilek <<"cd "<< pathtoskymaker<<'\n';

// run u file
ofstream runoutfileu("runu");

  runoutfileu <<"##  "<< '\n';
  runoutfileu <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfileu <<"##  "<< '\n';
  runoutfileu <<"##  runu"<< '\n';
  runoutfileu <<"## " <<'\n';
  runoutfileu <<"echo     > counteru " <<'\n';
  runoutfileu <<"echo START : >> counteru " <<'\n';
  runoutfileu <<"date >> counteru " <<'\n';
  runoutfileu <<"echo     >> counteru " <<'\n';

//  runoutfileu <<"cd "<< pathtoskymaker<<'\n';


// run b file
ofstream runoutfileb("runb");

  runoutfileb <<"##  "<< '\n';
  runoutfileb <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfileb <<"##  "<< '\n';
  runoutfileb <<"##  runb"<< '\n';
  runoutfileb <<"## " <<'\n';
  runoutfileb <<"echo     > counterb " <<'\n';
  runoutfileb <<"echo START : >> counterb " <<'\n';
  runoutfileb <<"date >> counterb " <<'\n';
  runoutfileb <<"echo     >> counterb " <<'\n';

//  runoutfileb <<"cd "<< pathtoskymaker<<'\n';


// run v file
ofstream runoutfilev("runv");

  runoutfilev <<"##  "<< '\n';
  runoutfilev <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfilev <<"##  "<< '\n';
  runoutfilev <<"##  runv"<< '\n';
  runoutfilev <<"## " <<'\n';
  runoutfilev <<"echo     > counterv " <<'\n';
  runoutfilev <<"echo START : >> counterv " <<'\n';
  runoutfilev <<"date >> counterv " <<'\n';
  runoutfilev <<"echo     >> counterv " <<'\n';

//  runoutfilev <<"cd "<< pathtoskymaker<<'\n';


// run r file
ofstream runoutfiler("runr");

  runoutfiler <<"##  "<< '\n';
  runoutfiler <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  runoutfiler <<"##  "<< '\n';
  runoutfiler <<"##  runr"<< '\n';
  runoutfiler <<"## " <<'\n';
  runoutfiler <<"echo     > counterr " <<'\n';
  runoutfiler <<"echo START : >> counterr " <<'\n';
  runoutfiler <<"date >> counterr " <<'\n';
  runoutfiler <<"echo     >> counterr " <<'\n';

//  runoutfiler <<"cd "<< pathtoskymaker<<'\n';

///////////////////////////////////
///  indextrek
char fileinuse[20], fileoutuse[20];
char fileoutusebandv[20],fileoutusebandu[20];
char fileoutusebandb[20],fileoutusebandj[20],fileoutusebandr[20];
char fileoutusebandh[20],fileoutusebandk[20],fileoutusebandi[20];
char fileplot[20]; ///

chdir("data"); 


int NOFILESOUT;
NOFILESOUT=(int)((alllines("indextrek")-7)/NOSETS) ;


  ifstream fileindex;
  fileindex.open("indextrek");

  if (fileindex.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (fileindex.peek()=='#') { fileindex.ignore(300,'\n');}



/// //////////////////////////////
///
/// "a" loop
///
/// //////////////////////////////

for (a=0;a<(NOFILESOUT);a++)
{


  fileindex >> fileinuse;
  fileindex >> fileoutusebandi;
  fileindex >> fileoutusebandj;
  fileindex >> fileoutusebandh;
  fileindex >> fileoutusebandk;
  fileindex >> fileoutusebandu;
  fileindex >> fileoutusebandb;
  fileindex >> fileoutusebandv;
  fileindex >> fileoutusebandr;
//  fileindex >> fileplot; ///
  fileindex.ignore(50,'\n');



chdir(".."); 
/// indextrek -END
//////////////////////////////////





  chdir("data");

  chdir("iso.trek");

  char *trekname;
  trekname=fileinuse;


  char *vlistname;
  vlistname=fileoutusebandv;

  char *ulistname;
  ulistname=fileoutusebandu;

  char *blistname;
  blistname=fileoutusebandb;

  char *jlistname;
  jlistname=fileoutusebandj;

  char *hlistname;
  hlistname=fileoutusebandh;

  char *klistname;
  klistname=fileoutusebandk;

  char *ilistname;
  ilistname=fileoutusebandi;

  char *rlistname;
  rlistname=fileoutusebandr;

  char *plotfilename; ///
  plotfilename=fileplot; ///


  int NOTREKLINES,NOTREKCOLUMNS, NOTREKSTARS;

  NOTREKLINES=datalinescolumn(trekname,1);
  
  NOTREKSTARS=datalinescolumn(trekname,1);

int wide2;

if (a==0)
{
wide2=(int)(log10(NOTREKSTARS)+1);
}
  

ifstream filein3;
filein3.open(trekname);

 if (filein3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filein3.peek()=='#') { filein3.ignore(400,'\n');}



if (VERBOSE==1)
{
  cout << "Reading file "<< trekname <<" ...";
}

int wide1;
wide1=(int)(log10(NOFILESOUT)+1);

if (VERBOSE==0)
{
  cout <<setw(wide1) << a+1 <<"/"<<NOFILESOUT <<" ...";
}



  chdir("..");

  chdir("..");



cout <<"... "<<setw(wide2)<< NOTREKSTARS <<" stars ";
cout << "... done !"<< '\n';



/*
//// read track file name

char trackname[24];

chdir("data");

ifstream filein99;

filein99.open("track");

if (filein99.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

filein99 >> trackname;
filein99.ignore(300,'\n');


filein99.close();
chdir("..");
*/

/*

// plot hr

//L-Teff

plothrfile <<"set size ratio 1.5 "<< '\n';

plothrfile << "set xlabel \" T_{eff} (K) \""<<'\n';
plothrfile << "set ylabel \" log(L) \""<<'\n';
plothrfile << "set nokey"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [1000:60000] reverse "<<'\n';

//plothrfile << "set xrange [:] reverse "<<'\n';

plothrfile << "set yrange [:] noreverse "<<'\n';

plothrfile << "set xtics 10000 "<<'\n';
plothrfile << "set mxtics 10 "<<'\n';


plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';


/////


if (AUTOSCALEHR==1)
{
plothrfile << "set autoscale y"<<'\n';
}

else
{
plothrfile << "set autoscale y"<<'\n';

}



//// mass labels

if (LABELSONOFF==1)
{
plothrfile <<" "<<'\n';
plothrfile <<"set label \"120\" at "<<X120<<","<<Y120<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"85\" at "<<X85<<","<<Y85<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"60\" at "<<X60<<","<<Y60<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"40\" at "<<X40<<","<<Y40<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"25\" at "<<X25<<","<<Y25<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"20\" at "<<X20<<","<<Y20<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"15\" at "<<X15<<","<<Y15<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"12\" at "<<X12<<","<<Y12<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"9\" at "<<X9<<","<<Y9<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"7\" at "<<X7<<","<<Y7<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"5\" at "<<X5<<","<<Y5<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"4\" at "<<X4<<","<<Y4<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"3\" at "<<X3<<","<<Y3<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"2.5\" at "<<X2_5<<","<<Y2_5<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"2\" at "<<X2<<","<<Y2<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"1.7\" at "<<X1_7<<","<<Y1_7<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"1.5\" at "<<X1_5<<","<<Y1_5<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"1.25\" at "<<X1_25<<","<<Y1_25<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';
plothrfile <<"set label \"1\" at "<<X1_0<<","<<Y1_0<<" font \""<<PLOTFONT<<","<<FONTSIZE2<<"\""<<'\n';


plothrfile <<" "<<'\n';


}

if (LABELSONOFF==0)
{
plothrfile <<" "<<'\n';
}

////
plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".LogLTeff.eps'"<<'\n';

if (HRONOFF==1)
{plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (10**($4)):($6) w l ls 2"<<", '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using (10**($3)):($5) w p ls 1" <<  '\n';
}

else 
{plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using (10**($3)):($5) w p ls 1"<< '\n';}







plothrfile <<" "<<'\n';




// V -(B-V)0

plothrfile <<"set size ratio 2 "<< '\n';

plothrfile << "set xlabel \" (B-V)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" V (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".VBV0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using ($9):($7+"<<apparent+A_V<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($7-$8-(" <<A_B-A_V<<")):($8) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($7-$8-(" <<A_B-A_V<<")):($8) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($7-$8-(" <<A_B-A_V<<")):($8) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($7-$8-(" <<A_B-A_V<<")):($8) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($7-$8-(" <<A_B-A_V<<")):($8) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';

// V -(B-V)



plothrfile <<"set size ratio 2 "<< '\n';

plothrfile << "set xlabel \" B-V (mag) \""<<'\n';
plothrfile << "set ylabel \" V (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}

plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".VBV.eps'"<<'\n';





if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using ($9+"<<A_B-A_V<<"):($7+"<<apparent+A_V<<") w l ls 2,";


if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($7-$8):($8) with points ls 3,";
}

plothrfile << " '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($7-$8):($8) with points ls 1 "<<  '\n';
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($7-$8):($8) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($7-$8):($8) with points ls 1"<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($7-$8):($8) with points ls 1"<<   '\n';
}

}

plothrfile <<" "<<'\n';


// B -(U-B)0


plothrfile << "set xlabel \" (U-B)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" B (mag)\""<<'\n';


plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 1.0 "<<'\n';
plothrfile << "set mxtics 10 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".BUB0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using ($8):(($7)+($9)+"<<apparent+A_B<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($6-$7-(" <<A_U-A_B<<")):($7) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($6-$7-(" <<A_U-A_B<<")):($7) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($6-$7-(" <<A_U-A_B<<")):($7) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($6-$7-(" <<A_U-A_B<<")):($7) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($6-$7-(" <<A_U-A_B<<")):($7) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';


// B -(U-B)



plothrfile << "set xlabel \" U-B (mag) \""<<'\n';
plothrfile << "set ylabel \" B (mag)\""<<'\n';



plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 1.0 "<<'\n';
plothrfile << "set mxtics 10 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".BUB.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using (($8)+(" <<A_U-A_B<<")):(($7)+($9)+"<<apparent+A_B<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($6-$7):($7) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($6-$7):($7) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($6-$7):($7) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($6-$7):($7) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($6-$7):($7) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';


// R -(V-R)0


plothrfile << "set xlabel \" (V-R)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" R (mag)\""<<'\n';


plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".RVR0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using (($10)):(($7)-($10)+"<<apparent+A_R<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($8-$9-(" <<A_V-A_R<<")):($9) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($8-$9-(" <<A_V-A_R<<")):($9) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($8-$9-(" <<A_V-A_R<<")):($9) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($8-$9-(" <<A_V-A_R<<")):($9) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($8-$9-(" <<A_V-A_R<<")):($9) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';


// R -(V-R)


plothrfile << "set xlabel \" V-R (mag) \""<<'\n';
plothrfile << "set ylabel \" R (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".RVR.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using (($10)+(" <<A_V-A_R<<")):(($7)-($10)+"<<apparent+A_R<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($8-$9):($9) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($8-$9):($9) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($8-$9):($9) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"'using ($8-$9):($9) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($8-$9):($9) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';



// I -(R-I)0



plothrfile << "set xlabel \" (R-I)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" I (mag)\""<<'\n';


plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".IRI0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using (($13)):(($7)-($11)+"<<apparent+A_I<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($9-$10-(" <<A_R-A_I<<")):($10) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($9-$10-(" <<A_R-A_I<<")):($10) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($9-$10-(" <<A_R-A_I<<")):($10) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($9-$10-(" <<A_R-A_I<<")):($10) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($9-$10-(" <<A_R-A_I<<")):($10) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';



// I -(R-I)



plothrfile << "set xlabel \" R-I (mag) \""<<'\n';
plothrfile << "set ylabel \" I (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".IRI.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"'  using (($13)+(" <<A_R-A_I<<")):(($7)-($11)+"<<apparent+A_I<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($9-$10):($10) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($9-$10):($10) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($9-$10):($10) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($9-$10):($10) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($9-$10):($10) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';




// J -(I-J)0



plothrfile << "set xlabel \" (I-J)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" J (mag)\""<<'\n';


plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".JIJ0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (($14)-($18)):(($7)+($18)-($12)+"<<apparent+A_J<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($10-$11-(" <<A_I-A_J<<")):($11) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($10-$11-(" <<A_I-A_J<<")):($11) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($10-$11-(" <<A_I-A_J<<")):($11) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($10-$11-(" <<A_I-A_J<<")):($11) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($10-$11-(" <<A_I-A_J<<")):($11) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';




// J -(I-J)



plothrfile << "set xlabel \" I-J (mag) \""<<'\n';
plothrfile << "set ylabel \" J (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".JIJ.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (($14)-($18)+(" <<A_I-A_J<<")):(($7)+($18)-($12)+"<<apparent+A_J<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($10-$11):($11) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($10-$11):($11) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($10-$11):($11) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($10-$11):($11) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($10-$11):($11) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';



// H -(J-H)0



plothrfile << "set xlabel \" (J-H)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" H (mag)\""<<'\n';


plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".HJH0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (($18)-($16)):(($7)+($18)-($12)-($15)+"<<apparent+A_H<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($11-$12-(" <<A_J-A_H<<")):($12) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($11-$12-(" <<A_J-A_H<<")):($12) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($11-$12-(" <<A_J-A_H<<")):($12) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($11-$12-(" <<A_J-A_H<<")):($12) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($11-$12-(" <<A_J-A_H<<")):($12) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';



// H -(J-H)



plothrfile << "set xlabel \" J-H (mag) \""<<'\n';
plothrfile << "set ylabel \" H (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.5 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".HJH.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (($18)-($16)+(" <<A_J-A_H<<")):(($7)+($18)-($12)-($15)+"<<apparent+A_H<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($11-$12):($12) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($11-$12):($12) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($11-$12):($12) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($11-$12):($12) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($11-$12):($12) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';




// K -(H-K)0



plothrfile << "set xlabel \" (H-K)_{0} (mag) \""<<'\n';
plothrfile << "set ylabel \" K (mag)\""<<'\n';


plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.25 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".KHK0.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (($16)):(($7)-($12)+"<<apparent+A_K<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($12-$13-(" <<A_H-A_K<<")):($13) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($12-$13-(" <<A_H-A_K<<")):($13) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($12-$13-(" <<A_H-A_K<<")):($13) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($12-$13-(" <<A_H-A_K<<")):($13) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($12-$13-(" <<A_H-A_K<<")):($13) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';




// K -(H-K)



plothrfile << "set xlabel \" H-K (mag) \""<<'\n';
plothrfile << "set ylabel \" K (mag)\""<<'\n';

plothrfile << "unset key"<<'\n';

plothrfile << "set autoscale x "<<'\n';
plothrfile << "set autoscale y "<<'\n';

plothrfile << "set xrange [:] noreverse "<<'\n';
plothrfile << "set yrange [:] reverse "<<'\n';

plothrfile << "set xtics 0.25 "<<'\n';
plothrfile << "set mxtics 5 "<<'\n';

plothrfile << "set ytics 1 "<<'\n';
plothrfile << "set mytics 10 "<<'\n';



if (FIELDONOFF==1)
{
plothrfile << "set autoscale x "<<'\n';
}


if (AUTOSCALE==1)
{
plothrfile << "set yrange [:] reverse" <<'\n';
}
else
{
plothrfile << "set yrange [:] reverse" <<'\n';
}


plothrfile <<"set output '"<<currentdirectory<<"/data/plots/"<<plotfilename<<".KHK.eps'"<<'\n';




if (HRONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/tracksisoUBVRIJHKLM/tracks.UBVRIJHKLM/"<<trackname<<"' using (($16)+(" <<A_H-A_K<<")):(($7)-($12)+"<<apparent+A_K<<") w l ls 2,";



if (FIELDONOFF==1)
{
plothrfile <<"'"<<currentdirectory<<"/data/field.plot' using ($12-$13):($13) with points ls 3,";
}

plothrfile << "'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($12-$13):($13) with points ls 1 ";
}

else
{

if (FIELDONOFF==1)
{
plothrfile <<"plot '"<<currentdirectory<<"/data/field.plot' using ($12-$13):($13) with points ls 3,";


plothrfile <<"'< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($12-$13):($13) with points ls 1 "<<   '\n';}

if (FIELDONOFF==0)
{
plothrfile <<"plot '< tail -"<<NOTREKSTARS-NOIGNORE<<" "<<currentdirectory<<"/data/iso.trek/"<<trekname<<"' using ($12-$13):($13) with points ls 1 "<<   '\n';
}


}

plothrfile <<" "<<'\n';

plothrfile <<" "<<'\n';

*/


/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////



/*
chdir("data");
chdir("tiff");
//// STIFF

runoutfileiTIFF <<"echo "<<ilistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<ilistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<ilistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<jlistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<jlistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<jlistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<hlistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<hlistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<hlistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<klistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<klistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<klistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<ulistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<ulistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<ulistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<blistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<blistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<blistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<vlistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<vlistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<vlistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<"echo "<<rlistname<<".fits" <<'\n'; 
runoutfileiTIFF <<"stiff "<< currentdirectory<<"/data/fits/"<<rlistname<<".fits -c ";
runoutfileiTIFF << currentdirectory <<"/data/stiff.conf -OUTFILE_NAME ";
runoutfileiTIFF << currentdirectory <<"/data/tiff/" <<rlistname<<".tif";

for (paraTIFF=0;paraTIFF<(NOPARAMTIFF);paraTIFF++)
{
runoutfileiTIFF <<" -" <<paramskymakerTIFF[paraTIFF]<<" ";
runoutfileiTIFF << paramvalueTIFF[paraTIFF];
}
runoutfileiTIFF <<'\n';
////
runoutfileiTIFF <<'\n';

/////////////////////////////////////////////////////////////////////

////
chdir("..");
chdir("..");
*/


//---------------------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
chdir("ini.files");

  int headonoff;  


  ifstream data13("header.ini");

  if (data13.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data13.peek()=='#') { data13.ignore(300,'\n');}

  data13 >> headonoff; 
  data13.ignore(300,'\n');

  data13.close();


//  param file
int NOPARAM,NOPARAM_IMAGE;
int para,paraimage;
char startsky[100];

if (VERBOSE==1)
{
cout << "Reading file skymaker.param...";
}

ifstream paramfile;
paramfile.open("skymaker.param");

  if (paramfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (paramfile.peek()=='#') { paramfile.ignore(300,'\n');}

paramfile >> startsky; paramfile.ignore(300,'\n');

paramfile >> NOPARAM_IMAGE; paramfile.ignore(300,'\n');

char paramimagex[NOPARAM_IMAGE][100];

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
paramfile >> paramimagex[paraimage];
paramfile.ignore(300,'\n');
}

//////

paramfile >> NOPARAM; paramfile.ignore(300,'\n');


char paramskymaker[NOPARAM][100];
char paramvalue[NOPARAM][100];

for (para=0;para<(NOPARAM);para++)
{
paramfile >> paramskymaker[para];
paramfile >> paramvalue[para];
paramfile.ignore(300,'\n');
}

paramfile.ignore(300,'\n');

paramfile.close();

if (VERBOSE==1)
{
cout << "...done !"<<"\n";
}


chdir("..");
//---------------------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>





chdir("data");
chdir("star.sky");


  // I Band
runoutfilei <<"echo "<<ilistname<<".fits" <<'\n'; 
runoutfilei <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<ilistname<<" -c ";
runoutfilei << currentdirectory <<"/data/i.sky -IMAGE_NAME ";
runoutfilei << currentdirectory <<"/data/fits/" <<ilistname<<".fits";

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfilei <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}


runoutfilei <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD;

for (para=0;para<(NOPARAM);para++)
{
runoutfilei <<" -" <<paramskymaker[para]<<" ";
runoutfilei << paramvalue[para];
}



runoutfilei <<'\n';
runoutfilei<<"rm "<< currentdirectory <<"/data/fits/"<<ilistname<<".list"<<'\n';


  ofstream outfilei(ilistname);
if (VERBOSE==1)
{
  cout << "Writing file "<< ilistname << " ...";
}

if (headonoff==1)
{

  outfilei <<"##  "<< '\n';
  outfilei <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfilei <<"##  "<< '\n';
  outfilei <<"##  "<< '\n';

  outfilei << "# "<< ilistname <<'\n';
  outfilei << "##(star)   x         y         I    "<<'\n';
  outfilei << "## 1       2         3         4      "<<'\n';

}



  // J Band

runoutfilej <<"echo "<<jlistname<<".fits" <<'\n'; //////
runoutfilej <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<jlistname<<" -c ";
runoutfilej << currentdirectory <<"/data/j.sky -IMAGE_NAME ";
runoutfilej << currentdirectory <<"/data/fits/" <<jlistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfilej <<" -"<<paramimagex[paraimage]<<" "<<WIDTH;
}



runoutfilej <<" -PIXEL_SIZE "<<FOV*60/WIDTH ;

for (para=0;para<(NOPARAM);para++)
{
runoutfilej <<" -" <<paramskymaker[para]<<" ";
runoutfilej << paramvalue[para];
}

runoutfilej <<'\n';
runoutfilej<<"rm "<< currentdirectory <<"/data/fits/"<<jlistname<<".list"<<'\n';


  ofstream outfilej(jlistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< jlistname << " ...";
}


if (headonoff==1)
{

  outfilej <<"##  "<< '\n';
  outfilej <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfilej <<"##  "<< '\n';
  outfilej <<"##  "<< '\n';

  outfilej << "# "<< jlistname <<'\n';
  outfilej << "##(star)   x         y         J    "<<'\n';
  outfilej << "## 1       2         3         4      "<<'\n';

}



  // H Band
runoutfileh <<"echo "<<hlistname<<".fits" <<'\n'; 
runoutfileh <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<hlistname<<" -c ";
runoutfileh << currentdirectory <<"/data/h.sky -IMAGE_NAME ";
runoutfileh << currentdirectory <<"/data/fits/" <<hlistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfileh <<" -"<<paramimagex[paraimage]<<" "<<WIDTH;
}



runoutfileh <<" -PIXEL_SIZE "<<FOV*60/WIDTH ;

for (para=0;para<(NOPARAM);para++)
{
runoutfileh <<" -" <<paramskymaker[para]<<" ";
runoutfileh << paramvalue[para];
}

runoutfileh <<'\n';
runoutfileh<<"rm "<< currentdirectory <<"/data/fits/"<<hlistname<<".list"<<'\n';


  ofstream outfileh(hlistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< hlistname << " ...";
}

if (headonoff==1)
{

  outfileh <<"##  "<< '\n';
  outfileh <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfileh <<"##  "<< '\n';
  outfileh <<"##  "<< '\n';

  outfileh << "# "<< hlistname <<'\n';
  outfileh << "##(star)   x         y         H    "<<'\n';
  outfileh << "## 1       2         3         4      "<<'\n';
}




  // K Band
runoutfilek <<"echo "<<klistname<<".fits" <<'\n'; 
runoutfilek <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<klistname<<" -c ";
runoutfilek << currentdirectory <<"/data/k.sky -IMAGE_NAME ";
runoutfilek << currentdirectory <<"/data/fits/" <<klistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfilek <<" -"<<paramimagex[paraimage]<<" "<<WIDTH;
}



runoutfilek <<" -PIXEL_SIZE "<<FOV*60/WIDTH ;

for (para=0;para<(NOPARAM);para++)
{
runoutfilek <<" -" <<paramskymaker[para]<<" ";
runoutfilek << paramvalue[para];
}

runoutfilek <<'\n';
runoutfilek<<"rm "<< currentdirectory <<"/data/fits/"<<klistname<<".list"<<'\n';


  ofstream outfilek(klistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< klistname << " ...";
}

if (headonoff==1)
{

  outfilek <<"##  "<< '\n';
  outfilek <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfilek <<"##  "<< '\n';
  outfilek <<"##  "<< '\n';

  outfilek << "# "<< klistname <<'\n';
  outfilek << "##(star)   x         y         K    "<<'\n';
  outfilek << "## 1       2         3         4      "<<'\n';
}






  // U Band
runoutfileu <<"echo "<<ulistname<<".fits" <<'\n'; 
runoutfileu <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<ulistname<<" -c ";
runoutfileu << currentdirectory <<"/data/u.sky -IMAGE_NAME ";
runoutfileu << currentdirectory <<"/data/fits/" <<ulistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfileu <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}



runoutfileu <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runoutfileu <<" -" <<paramskymaker[para]<<" ";
runoutfileu << paramvalue[para];
}

runoutfileu <<'\n';
runoutfileu<<"rm "<< currentdirectory <<"/data/fits/"<<ulistname<<".list"<<'\n';


  ofstream outfileu(ulistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< ulistname << " ...";
}

if (headonoff==1)
{

  outfileu <<"##  "<< '\n';
  outfileu <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfileu <<"##  "<< '\n';
  outfileu <<"##  "<< '\n';

  outfileu << "# "<< ulistname <<'\n';
  outfileu << "##(star)   x         y         U    "<<'\n';
  outfileu << "## 1       2         3         4      "<<'\n';
}






  // B Band
runoutfileb <<"echo "<<blistname<<".fits" <<'\n'; 
runoutfileb <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<blistname<<" -c ";
runoutfileb << currentdirectory <<"/data/b.sky -IMAGE_NAME ";
runoutfileb << currentdirectory <<"/data/fits/" <<blistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfileb <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}



runoutfileb <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runoutfileb <<" -" <<paramskymaker[para]<<" ";
runoutfileb << paramvalue[para];
}

runoutfileb <<'\n';
runoutfileb<<"rm "<< currentdirectory <<"/data/fits/"<<blistname<<".list"<<'\n';


  ofstream outfileb(blistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< blistname << " ...";
}

if (headonoff==1)
{

  outfileb <<"##  "<< '\n';
  outfileb <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfileb <<"##  "<< '\n';
  outfileb <<"##  "<< '\n';

  outfileb << "# "<< blistname <<'\n';
  outfileb << "##(star)   x         y         B    "<<'\n';
  outfileb << "## 1       2         3         4      "<<'\n';

}



  // V Band
runoutfilev <<"echo "<<vlistname<<".fits" <<'\n'; 
runoutfilev <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<vlistname<<" -c ";
runoutfilev << currentdirectory <<"/data/v.sky -IMAGE_NAME ";
runoutfilev << currentdirectory <<"/data/fits/" <<vlistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfilev <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}



runoutfilev <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runoutfilev <<" -" <<paramskymaker[para]<<" ";
runoutfilev << paramvalue[para];
}

runoutfilev <<'\n';
runoutfilev<<"rm "<< currentdirectory <<"/data/fits/"<<vlistname<<".list"<<'\n';


  ofstream outfilev(vlistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< vlistname << " ...";
}

if (headonoff==1)
{

  outfilev <<"##  "<< '\n';
  outfilev <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfilev <<"##  "<< '\n';
  outfilev <<"##  "<< '\n';

  outfilev << "# "<< vlistname <<'\n';
  outfilev << "##(star)   x         y         V    "<<'\n';
  outfilev << "## 1       2         3         4      "<<'\n';

}



  // R Band
runoutfiler <<"echo "<<rlistname<<".fits" <<'\n'; 
runoutfiler <<startsky<<" "<< currentdirectory<<"/data/star.sky/"<<rlistname<<" -c ";
runoutfiler << currentdirectory <<"/data/r.sky -IMAGE_NAME ";
runoutfiler << currentdirectory <<"/data/fits/" <<rlistname<<".fits";


for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runoutfiler <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}


runoutfiler <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runoutfiler <<" -" <<paramskymaker[para]<<" ";
runoutfiler << paramvalue[para];
}

runoutfiler <<'\n';
runoutfiler<<"rm "<< currentdirectory <<"/data/fits/"<<rlistname<<".list"<<'\n';


  ofstream outfiler(rlistname);

if (VERBOSE==1)
{
  cout << "Writing file "<< rlistname << " ...";
}

if (headonoff==1)
{

  outfiler <<"##  "<< '\n';
  outfiler <<"## B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfiler <<"##  "<< '\n';
  outfiler <<"##  "<< '\n';

  outfiler << "# "<< rlistname <<'\n';
  outfiler << "##(star)   x         y         V    "<<'\n';
  outfiler << "## 1       2         3         4      "<<'\n';
}



////// ----------------------------------------------------------------*************************




for (trektrek=0;trektrek<(NOTREKSTARS);trektrek++)
 {
 
 
while (filein3.peek()=='#') { filein3.ignore(500,'\n');}

 

filein3 >> sare; filein3 >> sare; filein3 >> sare; filein3 >> sare; filein3 >> sare;

filein3 >> uband;
filein3 >> bband;
filein3 >> vband;
filein3 >> rband;
filein3 >> iband;
filein3 >> jband;
filein3 >> hband;
filein3 >> kband;

filein3 >> xcoord;
filein3 >> ycoord;




 filein3.ignore(300, '\n');


outfileu.setf(ios::fixed,ios::floatfield);
outfileu.precision(8);
outfileu << "100 "<< setw(18)<<xcoord<<" "<<setw(18)<<ycoord<<" "<<setw(14)<< uband <<'\n';

outfileb.setf(ios::fixed,ios::floatfield);
outfileb.precision(8);
outfileb << "100 "<< setw(18)<<xcoord<<" "<<setw(18)<<ycoord<<" "<<setw(14)<< bband <<'\n';

outfilev.setf(ios::fixed,ios::floatfield);
outfilev.precision(8);
outfilev << "100 "<< setw(18)<<xcoord<<" "<<setw(18)<<ycoord<<" "<<setw(14)<< vband <<'\n';

outfiler.setf(ios::fixed,ios::floatfield);
outfiler.precision(8);
outfiler << "100 "<< setw(18)<<xcoord<<" "<<setw(18)<<ycoord<<" "<<setw(14)<< rband <<'\n';

outfilei.setf(ios::fixed,ios::floatfield);
outfilei.precision(8);
outfilei << "100 "<< setw(18)<<xcoord<<" "<<setw(18)<<ycoord<<" "<<setw(14)<< iband <<'\n';

outfilej.setf(ios::fixed,ios::floatfield);
outfilej.precision(8);
outfilej << "100 "<< setw(18)<<xcoord*WIDTH/WIDTH_CCD<<" "<<setw(18)<<ycoord*HEIGHT/HEIGHT_CCD<<" "<<setw(14)<< jband <<'\n';

outfileh.setf(ios::fixed,ios::floatfield);
outfileh.precision(8);
outfileh << "100 "<< setw(18)<<xcoord*WIDTH/WIDTH_CCD<<" "<<setw(18)<<ycoord*HEIGHT/HEIGHT_CCD<<" "<<setw(14)<< hband <<'\n';

outfilek.setf(ios::fixed,ios::floatfield);
outfilek.precision(8);
outfilek << "100 "<< setw(18)<<xcoord*WIDTH/WIDTH_CCD<<" "<<setw(18)<<ycoord*HEIGHT/HEIGHT_CCD<<" "<<setw(14)<< kband <<'\n';



}


outfileu.close();
outfileb.close();
outfilev.close();
outfiler.close();
outfilei.close();
outfilej.close();
outfileh.close();
outfilek.close();


///--------------------------------------------------------------------*************************





//// add background


addbackground<<"cat "<<currentdirectory<<"/data/background.U.list >>"<<currentdirectory<<"/data/star.sky/"<<ulistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.B.list >>"<<currentdirectory<<"/data/star.sky/"<<blistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.V.list >>"<<currentdirectory<<"/data/star.sky/"<<vlistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.R.list >>"<<currentdirectory<<"/data/star.sky/"<<rlistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.I.list >>"<<currentdirectory<<"/data/star.sky/"<<ilistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.J.list >>"<<currentdirectory<<"/data/star.sky/"<<jlistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.H.list >>"<<currentdirectory<<"/data/star.sky/"<<hlistname <<"\n";
addbackground<<"cat "<<currentdirectory<<"/data/background.K.list >>"<<currentdirectory<<"/data/star.sky/"<<klistname <<"\n";
addbackground<<"\n";



}
// loop a END
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////




chdir(".."); //
chdir(".."); //



///////////////--------------------------------------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
chdir("ini.files"); //

//  param file
int NOPARAM,NOPARAM_IMAGE;
int para,paraimage;
char startsky[100];

if (VERBOSE==1)
{
cout << "Reading file skymaker.param...";
}

ifstream paramfile;
paramfile.open("skymaker.param");

  if (paramfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (paramfile.peek()=='#') { paramfile.ignore(300,'\n');}

paramfile >> startsky; paramfile.ignore(300,'\n');

paramfile >> NOPARAM_IMAGE; paramfile.ignore(300,'\n');

char paramimagex[NOPARAM_IMAGE][100];

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
paramfile >> paramimagex[paraimage];
paramfile.ignore(300,'\n');
}

//////

paramfile >> NOPARAM; paramfile.ignore(300,'\n');


char paramskymaker[NOPARAM][100];
char paramvalue[NOPARAM][100];

for (para=0;para<(NOPARAM);para++)
{
paramfile >> paramskymaker[para];
paramfile >> paramvalue[para];
paramfile.ignore(300,'\n');
}

paramfile.ignore(300,'\n');

paramfile.close();

if (VERBOSE==1)
{
cout << "...done !"<<"\n";
}









chdir(".."); //

///////////////--------------------------------------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/////

addbackground<<"echo ... done ! "<<"\n";

addbackground<<"echo     "<<"\n";

addbackground<<"echo ... all done ! "<<"\n";

addbackground<<"echo     "<<"\n";

addbackground.close();


//////////////////
////  counter



////


runoutfilei <<"cd "<<currentdirectory<<'\n';
runoutfilei <<"echo END : >> counteri " <<'\n';
runoutfilei <<"date >> counteri" <<'\n';
runoutfilei <<"echo    >> counteri " <<'\n';
runoutfilei <<"cat counteri" <<'\n';

 



runoutfilej <<"cd "<<currentdirectory<<'\n';
runoutfilej <<"echo END : >> counterj " <<'\n';
runoutfilej <<"date >> counterj" <<'\n';
runoutfilej <<"echo    >> counterj " <<'\n';
runoutfilej <<"cat counterj" <<'\n';


 



runoutfileh <<"cd "<<currentdirectory<<'\n';
runoutfileh <<"echo END : >> counterh " <<'\n';
runoutfileh <<"date >> counterh" <<'\n';
runoutfileh <<"echo    >> counterh " <<'\n';
runoutfileh <<"cat counterh" <<'\n';

 


runoutfilek <<"cd "<<currentdirectory<<'\n';
runoutfilek <<"echo END : >> counterk " <<'\n';
runoutfilek <<"date >> counterk" <<'\n';
runoutfilek <<"echo    >> counterk " <<'\n';
runoutfilek <<"cat counterk" <<'\n';


 


runoutfileu <<"cd "<<currentdirectory<<'\n';
runoutfileu <<"echo END : >> counteru " <<'\n';
runoutfileu <<"date >> counteru" <<'\n';
runoutfileu <<"echo    >> counteru " <<'\n';
runoutfileu <<"cat counteru" <<'\n';




runoutfileb <<"cd "<<currentdirectory<<'\n';
runoutfileb <<"echo END : >> counterb " <<'\n';
runoutfileb <<"date >> counterb" <<'\n';
runoutfileb <<"echo    >> counterb " <<'\n';
runoutfileb <<"cat counterb" <<'\n';




runoutfilev <<"cd "<<currentdirectory<<'\n';
runoutfilev <<"echo END : >> counterv " <<'\n';
runoutfilev <<"date >> counterv" <<'\n';
runoutfilev <<"echo    >> counterv " <<'\n';
runoutfilev <<"cat counterv" <<'\n';



runoutfiler <<"cd "<<currentdirectory<<'\n';
runoutfiler <<"echo END : >> counterr " <<'\n';
runoutfiler <<"date >> counterr" <<'\n';
runoutfiler <<"echo    >> counterr " <<'\n';
runoutfiler <<"cat counterr" <<'\n';


 



if (VERBOSE==1)
{
cout << "Writing file runi ...";
cout <<"... done !" <<"\n";
}
runoutfilei.close();

if (VERBOSE==1)
{
cout << "Writing file runj ...";
cout <<"... done !" <<"\n";
}
runoutfilej.close();

if (VERBOSE==1)
{
cout << "Writing file runh ...";
cout <<"... done !" <<"\n";
}
runoutfileh.close();

if (VERBOSE==1)
{
cout << "Writing file runk ...";
cout <<"... done !" <<"\n";
}
runoutfilek.close();

if (VERBOSE==1)
{
cout << "Writing file runu ...";
cout <<"... done !" <<"\n";
}
runoutfileu.close();

if (VERBOSE==1)
{
cout << "Writing file runb ...";
cout <<"... done !" <<"\n";
}
runoutfileb.close();

if (VERBOSE==1)
{
cout << "Writing file runv ...";
cout <<"... done !" <<"\n";
}
runoutfilev.close();

if (VERBOSE==1)
{
cout << "Writing file runr ...";
cout <<"... done !" <<"\n";
}
runoutfiler.close();



if (VERBOSE==1)
{


cout << "Writing file add_field...";
cout <<"... done !" <<"\n";

cout << "Writing file runfield...";
cout <<"... done !" <<"\n";
}

// run background skymaker

runback <<"echo background.U.fits" <<'\n';
//runback <<"cd "<< pathtoskymaker<<"\n";
runback <<startsky<<" "<< currentdirectory<<"/data/background.U.list -c ";
runback << currentdirectory <<"/data/u.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.U.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.U.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';

///////////////////////////

runback <<"echo background.B.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.B.list -c ";
runback << currentdirectory <<"/data/b.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.B.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.B.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////


///////////////////////////

runback <<"echo background.V.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.V.list -c ";
runback << currentdirectory <<"/data/v.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.V.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.V.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////
///////////////////////////

runback <<"echo background.R.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.R.list -c ";
runback << currentdirectory <<"/data/r.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.R.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.R.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////
///////////////////////////

runback <<"echo background.I.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.I.list -c ";
runback << currentdirectory <<"/data/i.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.I.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.I.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////
///////////////////////////

runback <<"echo background.J.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.J.list -c ";
runback << currentdirectory <<"/data/j.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.J.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.J.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////
///////////////////////////

runback <<"echo background.H.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.H.list -c ";
runback << currentdirectory <<"/data/h.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.H.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.H.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////
///////////////////////////

runback <<"echo background.K.fits" <<'\n'; 
runback <<startsky<<" "<< currentdirectory<<"/data/background.K.list -c ";
runback << currentdirectory <<"/data/k.sky -IMAGE_NAME ";
runback << currentdirectory <<"/data/fits/background.K.fits";

//

for (paraimage=0;paraimage<(NOPARAM_IMAGE);paraimage++)
{
runback <<" -"<<paramimagex[paraimage]<<" "<<WIDTH_CCD;
}

runback <<" -PIXEL_SIZE "<<FOV*60/WIDTH_CCD ;

for (para=0;para<(NOPARAM);para++)
{
runback <<" -" <<paramskymaker[para]<<" ";
runback << paramvalue[para];
}

runback <<'\n';
runback<<"rm "<< currentdirectory <<"/data/fits/background.K.list"<<'\n';

//
runback <<"echo ... done !" <<'\n'; 
runback <<"echo     " <<'\n'; 
runback <<'\n';
/////////////////////////////////////////////

runback <<"echo     " <<'\n'; 
runback <<"echo ... all done !" <<'\n'; 
runback <<"echo     " <<'\n'; 

runback.close();
////



cout <<'\n';




cout <<"... all done !" <<"\n";
cout <<'\n';




 return 0;

}
