////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : gotrek2
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//                                           
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    gotrek2.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////



#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 
#include <stdlib.h> 

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>



#define NOCOLUMNS 1


using namespace std;



int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[500];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,500,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,500,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
           
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(500,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(500,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}


int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////

int main()
{
  cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goTREK2' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";

int OFF;//=0; //1


double aa,bb;

//  cluster.ini
double masstotal,r_c,r_t,r_a,r_a2,dd,FOV,WIDTH,HEIGHT,WIDTH_CCD,HEIGHT_CCD,A_U,A_B,A_V,A_R,A_I,A_J,A_H,A_K,secz;
double A_U2,A_B2,A_V2,A_R2,A_I2,A_J2,A_H2,A_K2;
double A_U3,A_B3,A_V3,A_R3,A_I3,A_J3,A_H3,A_K3;
double A_U4,A_B4,A_V4,A_R4,A_I4,A_J4,A_H4,A_K4;
double K_U,K_B,K_V,K_R,K_I,K_J,K_H,K_K;
int VERBOSE, ccm_on_off;
int REBTYPE;
double R_V,PHOTERR;
  double segregation;
  double seg_index;

double A_VISTAZ, A_VISTAY, A_VISTAJ, A_VISTAH, A_VISTAKS;
double A_VISTAZ2, A_VISTAY2, A_VISTAJ2, A_VISTAH2, A_VISTAKS2;
double A_VISTAZ3, A_VISTAY3, A_VISTAJ3, A_VISTAH3, A_VISTAKS3;
double A_VISTAZ4, A_VISTAY4, A_VISTAJ4, A_VISTAH4, A_VISTAKS4;


chdir("ini.files");

 ifstream data13("header.ini");

  if (data13.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data13.peek()=='#') { data13.ignore(300,'\n');}

  data13 >> OFF; 
  data13.ignore(300,'\n');

  data13.close();


ifstream setsfile;
setsfile.open("sets.ini");

  if (setsfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (setsfile.peek()=='#') { setsfile.ignore(300,'\n');}

int ss;
setsfile >> ss; setsfile.ignore(300,'\n');
setsfile.close();


ifstream clusterfile;
clusterfile.open("cluster.ini");

  if (clusterfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (clusterfile.peek()=='#') { clusterfile.ignore(300,'\n');}

clusterfile >> VERBOSE; clusterfile.ignore(300,'\n');
clusterfile >> masstotal; clusterfile.ignore(300,'\n');
clusterfile >> dd; clusterfile.ignore(300,'\n');
clusterfile >> FOV; clusterfile.ignore(300,'\n');
clusterfile >> WIDTH; clusterfile.ignore(300,'\n');
clusterfile >> HEIGHT; clusterfile.ignore(300,'\n');
clusterfile >> WIDTH_CCD; clusterfile.ignore(300,'\n');
clusterfile >> HEIGHT_CCD; clusterfile.ignore(300,'\n');
clusterfile >> ccm_on_off; clusterfile.ignore(300,'\n');
clusterfile >> R_V; clusterfile.ignore(300,'\n');
//clusterfile >> secz; clusterfile.ignore(300,'\n'); ///out
clusterfile >> A_U2; clusterfile.ignore(300,'\n');
clusterfile >> A_B2; clusterfile.ignore(300,'\n');
clusterfile >> A_V2; clusterfile.ignore(300,'\n');
clusterfile >> A_R2; clusterfile.ignore(300,'\n');
clusterfile >> A_I2; clusterfile.ignore(300,'\n');
clusterfile >> A_J2; clusterfile.ignore(300,'\n');
clusterfile >> A_H2; clusterfile.ignore(300,'\n');
clusterfile >> A_K2; clusterfile.ignore(300,'\n');

clusterfile >> A_VISTAZ2; clusterfile.ignore(300,'\n');
clusterfile >> A_VISTAY2; clusterfile.ignore(300,'\n');
clusterfile >> A_VISTAJ2; clusterfile.ignore(300,'\n');
clusterfile >> A_VISTAH2; clusterfile.ignore(300,'\n');
clusterfile >> A_VISTAKS2; clusterfile.ignore(300,'\n');

/*
clusterfile >> K_U; clusterfile.ignore(300,'\n');
clusterfile >> K_B; clusterfile.ignore(300,'\n');
clusterfile >> K_V; clusterfile.ignore(300,'\n');
clusterfile >> K_R; clusterfile.ignore(300,'\n');
clusterfile >> K_I; clusterfile.ignore(300,'\n');
clusterfile >> K_J; clusterfile.ignore(300,'\n');
clusterfile >> K_H; clusterfile.ignore(300,'\n');
clusterfile >> K_K; clusterfile.ignore(300,'\n');
*/

/*
clusterfile >> segregation; clusterfile.ignore(300,'\n');
clusterfile >> seg_index; clusterfile.ignore(300,'\n');
clusterfile >> REBTYPE; clusterfile.ignore(300,'\n');
clusterfile >> PHOTERR; clusterfile.ignore(300,'\n');
*/

clusterfile.ignore(300,'\n');

clusterfile.close();


// distance modulus

  double apparent;

  apparent=5.*log10(dd/10.);
    



if (VERBOSE==1)
{
cout << "Reading file cluster.ini...";

cout << "...done !"<<'\n';
}

chdir("..");

///// end cluster.ini


chdir("data");

if (VERBOSE==1)
{
cout << "Reading file ccm.filters...";
}

ifstream filterfile1;
filterfile1.open("ccm.filters");

  if (filterfile1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filterfile1.peek()=='#') { filterfile1.ignore(300,'\n');}

filterfile1 >> A_U3; filterfile1.ignore(300,'\n');
filterfile1 >> A_B3; filterfile1.ignore(300,'\n');
filterfile1 >> A_V3; filterfile1.ignore(300,'\n');
filterfile1 >> A_R3; filterfile1.ignore(300,'\n');
filterfile1 >> A_I3; filterfile1.ignore(300,'\n');
filterfile1 >> A_J3; filterfile1.ignore(300,'\n');
filterfile1 >> A_H3; filterfile1.ignore(300,'\n');
filterfile1 >> A_K3; filterfile1.ignore(300,'\n');

filterfile1 >> A_VISTAZ3; filterfile1.ignore(300,'\n');
filterfile1 >> A_VISTAY3; filterfile1.ignore(300,'\n');
filterfile1 >> A_VISTAJ3; filterfile1.ignore(300,'\n');
filterfile1 >> A_VISTAH3; filterfile1.ignore(300,'\n');
filterfile1 >> A_VISTAKS3; filterfile1.ignore(300,'\n');


filterfile1.ignore(300,'\n');

filterfile1.close();

if (VERBOSE==1)
{
cout << "...done !"<<'\n';
cout <<'\n';
}

//chdir(".."); 



if (ccm_on_off==0)
{
A_U4=A_U2;
A_B4=A_B2;
A_V4=A_V2;
A_R4=A_R2;
A_I4=A_I2;
A_J4=A_J2;
A_H4=A_H2;
A_K4=A_K2;

A_VISTAZ4=A_VISTAZ2;
A_VISTAY4=A_VISTAY2;
A_VISTAJ4=A_VISTAJ2;
A_VISTAH4=A_VISTAH2;
A_VISTAKS4=A_VISTAKS2;

}


if (ccm_on_off==1)
{

A_U4=A_U3;
A_B4=A_B3;
A_V4=A_V3;
A_R4=A_R3;
A_I4=A_I3;
A_J4=A_J3;
A_H4=A_H3;
A_K4=A_K3;

A_VISTAZ4=A_VISTAZ3;
A_VISTAY4=A_VISTAY3;
A_VISTAJ4=A_VISTAJ3;
A_VISTAH4=A_VISTAH3;
A_VISTAKS4=A_VISTAKS3;


}

A_U= A_U4;
A_B=A_B4;
A_V=A_V4;
A_R=A_R4;
A_I=A_I4;
A_J=A_J4;
A_H=A_H4;
A_K=A_K4;

A_VISTAZ=A_VISTAZ4;
A_VISTAY=A_VISTAY4;
A_VISTAJ=A_VISTAJ4;
A_VISTAH=A_VISTAH4;
A_VISTAKS=A_VISTAKS4;




chdir("..");


  ///read coordinates from 'king.out'

  chdir("data"); 

/*
if (VERBOSE==1)
{
  cout << "Reading file king.out...";
}
*/


/*
  int NOTOTALXY;

//  NOTOTALXY=datalinescolumn("king.out",1);
    NOTOTALXY=datalinescolumn("n_distribution.out2",1);
*/
  
  
  int ii, iking;



double xking,yking;


//filein2.close();

if (VERBOSE==1)
{
cout << "...done !"<<'\n';
}



chdir("..");



  
  int NOLINES,NODATALINES,NOCOL;
  int i,k,j,n,s,p,u,v,t,a,b,c,d,e,pq;

 

  char *filename;

  

  /// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);



/// ///////////////////////////////////////////////////////////////////
/// goINDEXTREK ///////////////////////////////////////////////////////


  system("ls isochrones/iso.to.use/ > ././data/indexiso");

//  system("ls isochrones/tracks.UBVRIJHKLM/ > ././data/track");


  int ab;
  char nameinuse[14];
  char nameinuse2[14];



  chdir("data"); 
  int ALLFILES;
  ALLFILES=alllines("indexiso");


  ifstream fileinzero;
  fileinzero.open("indexiso");

  if (fileinzero.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  ofstream outfile("trek.in");

  if (outfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  outfile <<"#  "<< '\n';
  outfile <<"# B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile <<"# trek.in  "<< '\n';
  outfile <<"#  "<< '\n';
  outfile <<"# Note : EXACTLY 7 extra lines required "<< '\n';
  outfile <<"#  "<< '\n';
  outfile <<"##    Isochrone file            Output file "<< '\n';

  cout <<"Reading file indexiso ...";




for (ab=0;ab<(ALLFILES);ab++)
{

fileinzero.width(14);
fileinzero >> nameinuse;
fileinzero.ignore(30,'\n');

outfile << nameinuse<<".PADOVA"<<"     "<< nameinuse<<".trek" <<'\n';

if(fileinzero.eof()) break;
}

cout <<"... done !" <<"\n";
cout <<"Writing file trek.in ...";

fileinzero.close();
outfile.close();


//indextrek

  ifstream fileinzero2;
  fileinzero2.open("indexiso");

  if (fileinzero2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  ofstream outfile3("indextrek");

  if (outfile3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  outfile3 <<"#  "<< '\n';
  outfile3 <<"# B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile3 <<"# indextrek  "<< '\n';
  outfile3 <<"#  "<< '\n';
  outfile3 <<"# Note : EXACTLY 7 extra lines required "<< '\n';
  outfile3 <<"#  "<< '\n';
//*****
  outfile3 <<"##    Trek file            I band file         J band file         H band file            K band file           U band file            B band file          V band file              R band file     "<< '\n';
//  outfile3 <<"#  "<< '\n';


int aaaa;
for (aaaa=0;aaaa<(ALLFILES);aaaa++)
{

fileinzero2.width(14);
fileinzero2 >> nameinuse2;
fileinzero2.ignore(30,'\n');

outfile3 << nameinuse2<<".trek";

///****
outfile3 <<"  "<< nameinuse2<<".I.list" <<"  "<< nameinuse2<<".J.list" <<"  "<< nameinuse2<<".H.list" << "  "<< nameinuse2<<".K.list"<<"  "<< nameinuse2<<".U.list"<<"  "<<nameinuse2<<".B.list"<<"  "<<nameinuse2<<".V.list"<<"  "<<nameinuse2<<".R.list";

outfile3<<'\n';

if(fileinzero2.eof()) break;
}

cout <<"... done !" <<"\n";
cout <<"Writing file indextrek ...";


fileinzero2.close();
outfile.close();

cout <<"... done !" <<"\n";




//indextrek END

chdir("..");

cout <<'\n';


/// //////////////////////////////////////////////////////////////
/// goINDEXTREK //////////////////////////////////////////////////





/////////////////////////////////////
///
///  n_distribution.out2
///
  
  

  chdir("data");
  
 

  int NOMASS;//, NOSTAR;
  NOMASS=datalinescolumn("n_distribution.out2",1);
//  NOSTAR=datalinescolumn("n_distribution.out2",2);

//cout << NOSTAR<<'\n';
  
  
  


  chdir(".."); 


///
///
/////////////////////////////////////////////////
/// 
//

char fileinuse[24], fileoutuse[24];


chdir("data"); 



int NOFILESOUT;

NOFILESOUT=alllines("trek.in")-7 ;


ifstream filein;

  filein.open("trek.in");



  if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filein.peek()=='#') { filein.ignore(300,'\n');}
  
  

  


  

/// ////////////////////////////-------------------------------------------------------------
/// ////////////////////////////-------------------------------------------------------------
/// loop a

for (a=0;a<(NOFILESOUT);a++)
{
  


/// //// ///////////////////////////////////    
/// /// //// ----------------------------
/// /// loop ss==1  ss 1
if (ss==1)
{

//iking=0;
 

filein >> fileinuse;
filein >> fileoutuse;
filein.ignore(300,'\n');




chdir(".."); 


chdir("data");

/*
ifstream filein2;
filein2.open("king.out");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}
*/




  ifstream data4;

  data4.open("n_distribution.out2");

  if (data4.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



chdir("..");



  chdir("isochrones");

  chdir("iso.to.use");

  char *isoname;
  isoname=fileinuse;

if (VERBOSE==1)
{
  cout << "Reading file "<< isoname <<" ...";
}

if (VERBOSE==0)
{
  cout << setw(3) << a+1 <<"/"<< (int)(NOFILESOUT/ss)<<" UBVRIJHK ...";
}

  char *isotrek;
  isotrek=fileoutuse;



  ifstream data5;

  int NOISOS,NOISOSCOLUMNS;
  NOISOS=datalinescolumn(isoname,1);
  NOISOSCOLUMNS=datalinescolumn(isoname,2);
//  NOISOSCOLUMNS=alldatacolumns(isoname);
  NOISOSCOLUMNS=16; /// manual 19

  double iso_lines_in[NOISOS][NOISOSCOLUMNS];
  double iso_lines[NOISOS][NOISOSCOLUMNS];



  data5.open(isoname);

  chdir("..");

  chdir("..");

 if (data5.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data5.peek()=='#') { data5.ignore(300,'\n');}

 
if (VERBOSE==1)
{
cout << "... computing ...";
cout << "... done ! "<<'\n';
}

//cout << NOISOS <<"  "<<NOISOSCOLUMNS<<'\n';

  while (1)
{

for (s=0;s<(NOISOS);s++)
 {

       for (p=0;p<(NOISOSCOLUMNS);p++)  
            {
	    data5 >> iso_lines_in[s][p];

	    iso_lines[s][p]=iso_lines_in[s][p];
            }

	}

if(data5.eof()) break;
}

  data5.close();


 


  chdir("data");

  chdir("iso.trek");

 

if (VERBOSE==1)
{
cout << "Writing file "<< isotrek << " ...";
}





  ofstream outfile2(isotrek);

  if (outfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

//int OFF=1; //0

//OFF=0;

if (OFF==1)
{

  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  outfile2 <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile2 <<"##  http://massclean.org/"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile2 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile2 <<"##  "<< '\n';


  outfile2 <<"##  Mass of cluster: "<< masstotal <<" M_Sun"<<'\n';
  outfile2 <<"##  Distance: "<< dd <<" pc"<<'\n';
  outfile2 <<"##  Distance modulus: "<<apparent<<" mag"<< '\n';
  outfile2 <<"##  A_V: "<<A_V<<" mag"<< '\n';
  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  "<< isotrek <<'\n';
  outfile2 <<"##   age          M_init        M_act           logL             logT              U                  B                 V                R                I                 J                H                K            x("<< WIDTH <<")            y("<< HEIGHT<<")"<<'\n';
  outfile2 <<"##    1             2             3               4                5               6                  7                 8                9                10                11               12               13             14                 15"<<'\n';
} 

double minit,mact,logteff,logg,logl,mv,ub,bv,vr,vi,vk,ri,ik,jh,hk,kl,jk;

double umag,bmag,vmag,rmag,imag,jmag,hmag,kmag;

//double jmag2mass,hmag2mass,kmag2mass;


int skip;

int kingskip;


//cout << NOMASS <<'\n';


for (n=0;n<(NOMASS);n++)
 {

//cout << n <<'\n';

outfile2.setf(ios::fixed,ios::floatfield);

outfile2.precision(0);

chdir(".."); //data
// n_distribution.out2

double mass;
int number;



while (data4.peek()=='#') { data4.ignore(300,'\n');}



data4 >> mass;
data4 >> number;
/// add king /////////////////////////////////////////////////////////////////////////
data4 >> xking;
data4 >> yking;

data4.ignore(300,'\n');


chdir("iso.trek");

int nono=1;

  if ( (mass<iso_lines[0][2])  )

{
//cout << mass <<'\n';
s=0;

outfile2.precision(0);



for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);



outfile2 << setw(15);

   outfile2 << mass <<"  ";



outfile2 << setw(15);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";


outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";


    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_V <<"   "; /// v    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_R <<"  "; // r


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_I <<"  "; // i




    aa=(pow(10.,iso_lines[s+1][13])-pow(10.,iso_lines[s][13]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][13])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][13])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    jmag=log10(aa*mass+bb);
   


    aa=(pow(10.,iso_lines[s+1][14])-pow(10.,iso_lines[s][14]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][14])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][14])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    hmag=log10(aa*mass+bb);
   
    



    aa=(pow(10.,iso_lines[s+1][15])-pow(10.,iso_lines[s][15]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][15])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][15])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    kmag=log10(aa*mass+bb); 
   
 


outfile2 << setw(15);

   
    outfile2 << jmag + apparent + A_J <<"  ";// j
    
    outfile2 << setw(15);
    
    outfile2 << hmag + apparent + A_H <<"  ";// h
    
    outfile2 << setw(15);
    
    outfile2 << kmag + apparent + A_K <<"  ";// k

///////////////////////////////////////////
//// AICI KING
/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH <<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';
} //nono

}//// mass < distrib



outfile2.precision(0);

/// 0 - (NOISOS-2)
for (s=0;s<(NOISOS-1);s++)
 {

//cout << mass<<"  "<< iso_lines[s][2] <<'\n';

  if ((mass>=iso_lines[s][2]) && (mass<iso_lines[s+1][2]))
   {
//cout << mass <<'\n';

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);

outfile2 << setw(15);

    outfile2 << mass <<"  ";




    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   outfile2 << setw(15);
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_V <<"   "; /// v    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_R <<"  "; // r


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_I <<"  "; // i




    aa=(pow(10.,iso_lines[s+1][13])-pow(10.,iso_lines[s][13]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][13])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][13])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    jmag=log10(aa*mass+bb);
   


    aa=(pow(10.,iso_lines[s+1][14])-pow(10.,iso_lines[s][14]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][14])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][14])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    hmag=log10(aa*mass+bb);
   
    



    aa=(pow(10.,iso_lines[s+1][15])-pow(10.,iso_lines[s][15]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][15])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][15])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    kmag=log10(aa*mass+bb); 
   
 


outfile2 << setw(15);

  
    outfile2 << jmag + apparent + A_J <<"  ";// j
    
    outfile2 << setw(15);
    
    outfile2 << hmag + apparent + A_H <<"  ";// h
    
    outfile2 << setw(15);
    
    outfile2 << kmag + apparent + A_K <<"  ";// k
    
/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;
    
    
    


outfile2 <<'\n';



}//nono

   }

 }







if (mass==iso_lines[NOISOS-1][2]) // 

{



s=NOISOS-2;

outfile2.precision(0);

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";

 

outfile2.precision(10);


  

outfile2 << setw(16);

outfile2 << mass <<"  ";

outfile2 << setw(16);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_V <<"   "; /// v    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_R <<"  "; // r


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_I <<"  "; // i




    aa=(pow(10.,iso_lines[s+1][13])-pow(10.,iso_lines[s][13]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][13])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][13])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    jmag=log10(aa*mass+bb);
   


    aa=(pow(10.,iso_lines[s+1][14])-pow(10.,iso_lines[s][14]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][14])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][14])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    hmag=log10(aa*mass+bb);
   
    



    aa=(pow(10.,iso_lines[s+1][15])-pow(10.,iso_lines[s][15]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][15])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][15])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    kmag=log10(aa*mass+bb); 
   
 


outfile2 << setw(15);

  
    outfile2 << jmag + apparent + A_J <<"  ";// j
    
    outfile2 << setw(15);
    
    outfile2 << hmag + apparent + A_H <<"  ";// h
    
    outfile2 << setw(15);
    
    outfile2 << kmag + apparent + A_K <<"  ";// k
    
/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';

}//nono

}











} /// n loop


outfile2.close();






cout << "... done ! \n";

if (VERBOSE==1)
{
cout << '\n';
}

chdir("..");  


//// 
//////////////////////



}// ss ==1
/// /// //// ----------------------------
/// /// loop ss==1  ss 1
/// /// /// /////////////////////////////
/////////////////////////////////////////








/// //// ///////////////////////////////////    
/// /// //// ----------------------------
/// /// loop ss>1  ss 1
if ((ss>1) && (a<(int)(NOFILESOUT/ss)))
{

//iking=0;
 

filein >> fileinuse;
filein >> fileoutuse;
filein.ignore(300,'\n');




chdir(".."); 


chdir("data");

/*
ifstream filein2;
filein2.open("king.out");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}
*/




  ifstream data4;

  data4.open("n_distribution.out2");

  if (data4.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



chdir("..");



  chdir("isochrones");

  chdir("iso.to.use");

  char *isoname;
  isoname=fileinuse;

if (VERBOSE==1)
{
  cout << "Reading file "<< isoname <<" ...";
}

if (VERBOSE==0)
{
  cout << setw(3) << a+1 <<"/"<< (int)(NOFILESOUT/ss)<<" ("<<setw(3)<<a+1<<"/"<<NOFILESOUT<<") UBVRIJHK ...";
}

  char *isotrek;
  isotrek=fileoutuse;



  ifstream data5;

  int NOISOS,NOISOSCOLUMNS;
  NOISOS=datalinescolumn(isoname,1);
  NOISOSCOLUMNS=datalinescolumn(isoname,2);
//  NOISOSCOLUMNS=alldatacolumns(isoname);
  NOISOSCOLUMNS=16; /// manual 19

  double iso_lines_in[NOISOS][NOISOSCOLUMNS];
  double iso_lines[NOISOS][NOISOSCOLUMNS];



  data5.open(isoname);

  chdir("..");

  chdir("..");

 if (data5.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data5.peek()=='#') { data5.ignore(300,'\n');}

 
if (VERBOSE==1)
{
cout << "... computing ...";
cout << "... done ! "<<'\n';
}

//cout << NOISOS <<"  "<<NOISOSCOLUMNS<<'\n';

  while (1)
{

for (s=0;s<(NOISOS);s++)
 {

       for (p=0;p<(NOISOSCOLUMNS);p++)  
            {
	    data5 >> iso_lines_in[s][p];

	    iso_lines[s][p]=iso_lines_in[s][p];
            }

	}

if(data5.eof()) break;
}

  data5.close();


 


  chdir("data");

  chdir("iso.trek");

 

if (VERBOSE==1)
{
cout << "Writing file "<< isotrek << " ...";
}





  ofstream outfile2(isotrek);

  if (outfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

//OFF=0;
if (OFF==1)
{

  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  outfile2 <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile2 <<"##  http://massclean.org/"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile2 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Mass of cluster: "<< masstotal <<" M_Sun"<<'\n';
  outfile2 <<"##  Distance: "<< dd <<" pc"<<'\n';
  outfile2 <<"##  Distance modulus: "<<apparent<<" mag"<< '\n';
  outfile2 <<"##  A_V: "<<A_V<<" mag"<< '\n';
  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  "<< isotrek <<'\n';
  outfile2 <<"##   age          M_init        M_act           logL             logT              U                  B                 V                R                I                 J                H                K            x("<< WIDTH <<")            y("<< HEIGHT<<")"<<'\n';
  outfile2 <<"##    1             2             3               4                5               6                  7                 8                9                10                11               12               13             14                 15"<<'\n';
}

double minit,mact,logteff,logg,logl,mv,ub,bv,vr,vi,vk,ri,ik,jh,hk,kl,jk;

double umag,bmag,vmag,rmag,imag,jmag,hmag,kmag;

//double jmag2mass,hmag2mass,kmag2mass;


int skip;

int kingskip;


//cout << NOMASS <<'\n';


for (n=0;n<(NOMASS);n++)
 {

//cout << n <<'\n';

outfile2.setf(ios::fixed,ios::floatfield);

outfile2.precision(0);

chdir(".."); //data
// n_distribution.out2

double mass;
int number;



while (data4.peek()=='#') { data4.ignore(300,'\n');}



data4 >> mass;
data4 >> number;
data4 >> xking;
data4 >> yking;


data4.ignore(300,'\n');


chdir("iso.trek");

int nono=1;

  if ( (mass<iso_lines[0][2])  )

{
//cout << mass <<'\n';
s=0;

outfile2.precision(0);



for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);



outfile2 << setw(15);

   outfile2 << mass <<"  ";



outfile2 << setw(15);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";


outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";


    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_V <<"   "; /// v    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_R <<"  "; // r


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_I <<"  "; // i




    aa=(pow(10.,iso_lines[s+1][13])-pow(10.,iso_lines[s][13]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][13])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][13])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    jmag=log10(aa*mass+bb);
   


    aa=(pow(10.,iso_lines[s+1][14])-pow(10.,iso_lines[s][14]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][14])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][14])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    hmag=log10(aa*mass+bb);
   
    



    aa=(pow(10.,iso_lines[s+1][15])-pow(10.,iso_lines[s][15]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][15])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][15])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    kmag=log10(aa*mass+bb); 
   
 


outfile2 << setw(15);

   
    outfile2 << jmag + apparent + A_J <<"  ";// j
    
    outfile2 << setw(15);
    
    outfile2 << hmag + apparent + A_H <<"  ";// h
    
    outfile2 << setw(15);
    
    outfile2 << kmag + apparent + A_K <<"  ";// k


/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH <<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';
} //nono

}//// mass < distrib



outfile2.precision(0);

/// 0 - (NOISOS-2)
for (s=0;s<(NOISOS-1);s++)
 {

//cout << mass<<"  "<< iso_lines[s][2] <<'\n';

  if ((mass>=iso_lines[s][2]) && (mass<iso_lines[s+1][2]))
   {
//cout << mass <<'\n';

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);

outfile2 << setw(15);

    outfile2 << mass <<"  ";




    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   outfile2 << setw(15);
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_V <<"   "; /// v    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_R <<"  "; // r


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_I <<"  "; // i




    aa=(pow(10.,iso_lines[s+1][13])-pow(10.,iso_lines[s][13]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][13])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][13])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    jmag=log10(aa*mass+bb);
   


    aa=(pow(10.,iso_lines[s+1][14])-pow(10.,iso_lines[s][14]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][14])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][14])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    hmag=log10(aa*mass+bb);
   
    



    aa=(pow(10.,iso_lines[s+1][15])-pow(10.,iso_lines[s][15]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][15])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][15])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    kmag=log10(aa*mass+bb); 
   
 


outfile2 << setw(15);

  
    outfile2 << jmag + apparent + A_J <<"  ";// j
    
    outfile2 << setw(15);
    
    outfile2 << hmag + apparent + A_H <<"  ";// h
    
    outfile2 << setw(15);
    
    outfile2 << kmag + apparent + A_K <<"  ";// k
    
/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;
    
    
    


outfile2 <<'\n';



}//nono

   }

 }







if (mass==iso_lines[NOISOS-1][2]) // 

{



s=NOISOS-2;

outfile2.precision(0);

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";

 

outfile2.precision(10);


  

outfile2 << setw(16);

outfile2 << mass <<"  ";

outfile2 << setw(16);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_V <<"   "; /// v    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_R <<"  "; // r


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_I <<"  "; // i




    aa=(pow(10.,iso_lines[s+1][13])-pow(10.,iso_lines[s][13]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][13])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][13])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    jmag=log10(aa*mass+bb);
   


    aa=(pow(10.,iso_lines[s+1][14])-pow(10.,iso_lines[s][14]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][14])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][14])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    hmag=log10(aa*mass+bb);
   
    



    aa=(pow(10.,iso_lines[s+1][15])-pow(10.,iso_lines[s][15]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][15])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][15])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    kmag=log10(aa*mass+bb); 
   
 


outfile2 << setw(15);

  
    outfile2 << jmag + apparent + A_J <<"  ";// j
    
    outfile2 << setw(15);
    
    outfile2 << hmag + apparent + A_H <<"  ";// h
    
    outfile2 << setw(15);
    
    outfile2 << kmag + apparent + A_K <<"  ";// k
    
/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';

}//nono

}











} /// n loop


outfile2.close();






cout << "... done ! \n";

if (VERBOSE==1)
{
cout << '\n';
}

chdir("..");  


//// 
//////////////////////



}// ss >1
/// /// //// ----------------------------
/// /// loop ss>1  ss 1
/// /// /// /////////////////////////////
/////////////////////////////////////////



/// //// //////////////////////////////////////////////////////////////// VISTA    
/// /// //// ----------------------------
/// /// loop ss>=2  ss 2
if ((ss>=2) && (a>=(int)(NOFILESOUT/ss)) && (a<(int)(NOFILESOUT/ss*2)) )
{

//iking=0;
 

filein >> fileinuse;
filein >> fileoutuse;
filein.ignore(300,'\n');




chdir(".."); 


chdir("data");

/*
ifstream filein2;
filein2.open("king.out");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}
*/




  ifstream data4;

  data4.open("n_distribution.out2");

  if (data4.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



chdir("..");



  chdir("isochrones");

  chdir("iso.to.use");

  char *isoname;
  isoname=fileinuse;

if (VERBOSE==1)
{
  cout << "Reading file "<< isoname <<" ...";
}

if (VERBOSE==0)
{
  cout << setw(3) << a+1-(int)(NOFILESOUT/ss) <<"/"<< (int)(NOFILESOUT/ss)<<" ("<<setw(3)<<a+1<<"/"<<NOFILESOUT<<") VISTA ZYJHKs ...";
}

  char *isotrek;
  isotrek=fileoutuse;



  ifstream data5;

  int NOISOS,NOISOSCOLUMNS;
  NOISOS=datalinescolumn(isoname,1);
  NOISOSCOLUMNS=datalinescolumn(isoname,2);
//  NOISOSCOLUMNS=alldatacolumns(isoname);
  NOISOSCOLUMNS=13; /// manual 19 ///////////////////////////////////////////////////////////////////////

  double iso_lines_in[NOISOS][NOISOSCOLUMNS];
  double iso_lines[NOISOS][NOISOSCOLUMNS];



  data5.open(isoname);

  chdir("..");

  chdir("..");

 if (data5.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data5.peek()=='#') { data5.ignore(300,'\n');}

 
if (VERBOSE==1)
{
cout << "... computing ...";
cout << "... done ! "<<'\n';
}

//cout << NOISOS <<"  "<<NOISOSCOLUMNS<<'\n';

  while (1)
{

for (s=0;s<(NOISOS);s++)
 {

       for (p=0;p<(NOISOSCOLUMNS);p++)  
            {
	    data5 >> iso_lines_in[s][p];

	    iso_lines[s][p]=iso_lines_in[s][p];
            }

	}

if(data5.eof()) break;
}

  data5.close();


 


  chdir("data");

  chdir("iso.trek");

 

if (VERBOSE==1)
{
cout << "Writing file "<< isotrek << " ...";
}





  ofstream outfile2(isotrek);

  if (outfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }


//OFF=0;
if (OFF==1)
{


  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  outfile2 <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile2 <<"##  http://massclean.org/"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile2 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile2 <<"##  "<< '\n';


  outfile2 <<"##  Mass of cluster: "<< masstotal <<" M_Sun"<<'\n';
  outfile2 <<"##  Distance: "<< dd <<" pc"<<'\n';
  outfile2 <<"##  Distance modulus: "<<apparent<<" mag"<< '\n';
  outfile2 <<"##  A_V: "<<A_V<<" mag"<< '\n';
  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  "<< isotrek <<'\n';
  outfile2 <<"##   age          M_init        M_act           logL              logT              Z                 Y                 J                 H                Ks            x("<< WIDTH <<")           y("<< HEIGHT<<")"<<'\n';
  outfile2 <<"##    1             2             3               4                5                6                 7                 8                 9                10              11                12"<<'\n';
}

double minit,mact,logteff,logg,logl,mv,ub,bv,vr,vi,vk,ri,ik,jh,hk,kl,jk;

double umag,bmag,vmag,rmag,imag,jmag,hmag,kmag;

//double jmag2mass,hmag2mass,kmag2mass;


int skip;

int kingskip;


//cout << NOMASS <<'\n';


for (n=0;n<(NOMASS);n++)
 {

//cout << n <<'\n';

outfile2.setf(ios::fixed,ios::floatfield);

outfile2.precision(0);

chdir(".."); //data
// n_distribution.out2

double mass;
int number;



while (data4.peek()=='#') { data4.ignore(300,'\n');}



data4 >> mass;
data4 >> number;
data4 >> xking;
data4 >> yking;


data4.ignore(300,'\n');


chdir("iso.trek");

int nono=1;

  if ( (mass<iso_lines[0][2])  )

{
//cout << mass <<'\n';
s=0;

outfile2.precision(0);



for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);



outfile2 << setw(15);

   outfile2 << mass <<"  ";



outfile2 << setw(15);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";


outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";


    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_VISTAZ <<"   "; /// Z
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_VISTAY <<"   "; /// Y
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_VISTAJ <<"   "; ///  J  
    





outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_VISTAH <<"  "; // H


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_VISTAKS <<"  "; // Ks




/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH <<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';
} //nono

}//// mass < distrib



outfile2.precision(0);

/// 0 - (NOISOS-2)
for (s=0;s<(NOISOS-1);s++)
 {

//cout << mass<<"  "<< iso_lines[s][2] <<'\n';

  if ((mass>=iso_lines[s][2]) && (mass<iso_lines[s+1][2]))
   {
//cout << mass <<'\n';

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);

outfile2 << setw(15);

    outfile2 << mass <<"  ";




    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   outfile2 << setw(15);
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_VISTAZ <<"   "; /// Z
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_VISTAY <<"   "; /// Y
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_VISTAJ <<"   "; ///  J    
    




outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_VISTAH <<"  "; // H


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_VISTAKS <<"  "; // Ks



/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;
    
    
    


outfile2 <<'\n';



}//nono

   }

 }







if (mass==iso_lines[NOISOS-1][2]) // 

{



s=NOISOS-2;

outfile2.precision(0);

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";

 

outfile2.precision(10);


  

outfile2 << setw(16);

outfile2 << mass <<"  ";

outfile2 << setw(16);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    aa=(pow(10.,iso_lines[s+1][10])-pow(10.,iso_lines[s][10]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][10])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][10])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    vmag=log10(aa*mass+bb);

    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_VISTAZ <<"   "; /// Z
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_VISTAY <<"   "; /// Y
    
    outfile2 << setw(15);
    
    outfile2 << vmag + apparent +A_VISTAJ <<"   "; ///  J    
    


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][11])-pow(10.,iso_lines[s][11]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][11])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][11])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    rmag=log10(aa*mass+bb);

   
    outfile2 << rmag + apparent + A_VISTAH <<"  "; // H


outfile2 << setw(15);

    aa=(pow(10.,iso_lines[s+1][12])-pow(10.,iso_lines[s][12]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][12])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][12])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    imag=log10(aa*mass+bb);
   
    outfile2 << imag + apparent + A_VISTAKS <<"  "; // Ks



/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';

}//nono

}











} /// n loop


outfile2.close();






cout << "... done ! \n";

if (VERBOSE==1)
{
cout << '\n';
}

chdir("..");  


//// 
//////////////////////



}// ss >=2
/// /// //// ----------------------------
/// /// loop ss>=2  ss 2
/// /// /// /////////////////////////////
/////////////////////////////////////////






/// //// ///////////////////////////////////    
/// /// //// ----------------------------
/// /// loop ss>=3  ss 3
if ((ss>=3) && (a>=(int)(NOFILESOUT/ss*2)) && (a<(int)(NOFILESOUT/ss*3)) )
{

//iking=0;
 

filein >> fileinuse;
filein >> fileoutuse;
filein.ignore(300,'\n');




chdir(".."); 


chdir("data");

/*
ifstream filein2;
filein2.open("king.out");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}
*/




  ifstream data4;

  data4.open("n_distribution.out2");

  if (data4.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



chdir("..");



  chdir("isochrones");

  chdir("iso.to.use");

  char *isoname;
  isoname=fileinuse;

if (VERBOSE==1)
{
  cout << "Reading file "<< isoname <<" ...";
}

if (VERBOSE==0)
{
  cout << setw(3) << a+1-(int)(NOFILESOUT/ss*2) <<"/"<< (int)(NOFILESOUT/ss)<<" ("<<setw(3)<<a+1<<"/"<<NOFILESOUT<<") GALEX FUV,NUV ...";
}

  char *isotrek;
  isotrek=fileoutuse;



  ifstream data5;

  int NOISOS,NOISOSCOLUMNS;
  NOISOS=datalinescolumn(isoname,1);
  NOISOSCOLUMNS=datalinescolumn(isoname,2);
//  NOISOSCOLUMNS=alldatacolumns(isoname);
  NOISOSCOLUMNS=10; /// manual 19

  double iso_lines_in[NOISOS][NOISOSCOLUMNS];
  double iso_lines[NOISOS][NOISOSCOLUMNS];



  data5.open(isoname);

  chdir("..");

  chdir("..");

 if (data5.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data5.peek()=='#') { data5.ignore(300,'\n');}

 
if (VERBOSE==1)
{
cout << "... computing ...";
cout << "... done ! "<<'\n';
}

//cout << NOISOS <<"  "<<NOISOSCOLUMNS<<'\n';

  while (1)
{

for (s=0;s<(NOISOS);s++)
 {

       for (p=0;p<(NOISOSCOLUMNS);p++)  
            {
	    data5 >> iso_lines_in[s][p];

	    iso_lines[s][p]=iso_lines_in[s][p];
            }

	}

if(data5.eof()) break;
}

  data5.close();


 


  chdir("data");

  chdir("iso.trek");

 

if (VERBOSE==1)
{
cout << "Writing file "<< isotrek << " ...";
}





  ofstream outfile2(isotrek);

  if (outfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

//OFF=0;
if (OFF==1)
{


  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  outfile2 <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile2 <<"##  http://massclean.org/"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile2 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Mass of cluster: "<< masstotal <<" M_Sun"<<'\n';
  outfile2 <<"##  Distance: "<< dd <<" pc"<<'\n';
  outfile2 <<"##  Distance modulus: "<<apparent<<" mag"<< '\n';
  outfile2 <<"##  A_V: "<<A_V<<" mag"<< '\n';
  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  "<< isotrek <<'\n';
  outfile2 <<"##   age          M_init        M_act           logL           logT           FUV             NUV           x("<< WIDTH <<")          y("<< HEIGHT<<")"<<'\n';
  outfile2 <<"##    1             2             3               4              5             6               7               8                            9           "<<'\n';
}

double minit,mact,logteff,logg,logl,mv,ub,bv,vr,vi,vk,ri,ik,jh,hk,kl,jk;

double umag,bmag,vmag,rmag,imag,jmag,hmag,kmag;

//double jmag2mass,hmag2mass,kmag2mass;


int skip;

int kingskip;


//cout << NOMASS <<'\n';


for (n=0;n<(NOMASS);n++)
 {

//cout << n <<'\n';

outfile2.setf(ios::fixed,ios::floatfield);

outfile2.precision(0);

chdir(".."); //data
// n_distribution.out2

double mass;
int number;



while (data4.peek()=='#') { data4.ignore(300,'\n');}



data4 >> mass;
data4 >> number;
data4 >> xking;
data4 >> yking;


data4.ignore(300,'\n');


chdir("iso.trek");

int nono=1;

  if ( (mass<iso_lines[0][2])  )

{
//cout << mass <<'\n';
s=0;

outfile2.precision(0);



for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);



outfile2 << setw(15);

   outfile2 << mass <<"  ";



outfile2 << setw(15);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";


outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";


    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);



    


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
 


/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH <<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';
} //nono

}//// mass < distrib



outfile2.precision(0);

/// 0 - (NOISOS-2)
for (s=0;s<(NOISOS-1);s++)
 {

//cout << mass<<"  "<< iso_lines[s][2] <<'\n';

  if ((mass>=iso_lines[s][2]) && (mass<iso_lines[s+1][2]))
   {
//cout << mass <<'\n';

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";


outfile2.precision(10);

outfile2 << setw(15);

    outfile2 << mass <<"  ";




    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   outfile2 << setw(15);
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
 

/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;
    
    
    


outfile2 <<'\n';



}//nono

   }

 }







if (mass==iso_lines[NOISOS-1][2]) // 

{



s=NOISOS-2;

outfile2.precision(0);

for (nono=1;nono<=number;nono++)
{

outfile2.precision(2);
outfile2 << setw(6);
outfile2 << iso_lines[0][1] <<"  ";

 

outfile2.precision(10);


  

outfile2 << setw(16);

outfile2 << mass <<"  ";

outfile2 << setw(16);

    aa=(iso_lines[s+1][3]-iso_lines[s][3])/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(iso_lines[s][3]*iso_lines[s+1][2]-iso_lines[s+1][3]*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    mact=aa*mass+bb;
   
    outfile2 << mact <<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][4]<<"  ";

outfile2 << setw(15);

   outfile2 << iso_lines[s][5]<<"  ";




    aa=(pow(10.,iso_lines[s+1][8])-pow(10.,iso_lines[s][8]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][8])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][8])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    umag=log10(aa*mass+bb);
   

    aa=(pow(10.,iso_lines[s+1][9])-pow(10.,iso_lines[s][9]))/(iso_lines[s+1][2]-iso_lines[s][2]);
    bb=(pow(10.,iso_lines[s][9])*iso_lines[s+1][2]-pow(10.,iso_lines[s+1][9])*iso_lines[s][2])/(iso_lines[s+1][2]-iso_lines[s][2]);
    
    bmag=log10(aa*mass+bb);


    outfile2 << setw(15);
 
    outfile2 << umag + apparent + A_U <<"   "; /// u
    
    outfile2 << setw(15);
    
    outfile2 << bmag + apparent + A_B <<"   "; /// b
    
 

/*
filein2 >> xking;
filein2 >> yking;
*/

outfile2 << setw(15);
    outfile2 << xking * WIDTH<<"   ";
    
outfile2 << setw(15);
    outfile2 << yking * HEIGHT; 

    
    //iking++;


outfile2 <<'\n';

}//nono

}











} /// n loop


outfile2.close();






cout << "... done ! \n";

if (VERBOSE==1)
{
cout << '\n';
}

chdir("..");  


//// 
//////////////////////



}// ss >=3
/// /// //// ----------------------------
/// /// loop ss>=3  ss 3
/// /// /// /////////////////////////////
/////////////////////////////////////////










if(filein.eof()) break;
}
/// "a" loop
/// ///////////////////////////
/// ///////////////////////////


filein.close();

cout <<"... all done !" <<'\n';

cout <<'\n';



 return 0;

}
