////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : goscript
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//
//
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    goscript.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////


#include <cstdlib>
#include <ctime>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 
#include <stdlib.h> /// system("command");
#include <string.h>

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>


using namespace std;



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////



int main()
{

  cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goSCRIPT' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";



int NOISO=414;
int STARTISO=600;
int STEP=1;

int i;


////////////////////////

  system("ls ./../../isochrones/iso.to.use/ > indexiso");


  char nameinuse[14];

  ifstream fileinzero;
  fileinzero.open("indexiso");


fileinzero.width(14);
fileinzero >> nameinuse;
fileinzero.ignore(30,'\n');

fileinzero.close();

//cout << nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<'\n';


////////////////////////


ofstream outfile2("run.one");

  if (outfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



outfile2 << "cd .." <<'\n';
outfile2 << "cd .." <<'\n';

outfile2 << "./goimf2" <<'\n';
outfile2 << "./goking2" <<'\n';
outfile2 << "./gotrek2" <<'\n';

outfile2 << "cd utility" <<'\n';
outfile2 << "cd widecmd" <<'\n';

outfile2 << "./gogauss" <<'\n';


/////
/*
outfile2 << "cd .." <<'\n';
outfile2 << "cd .." <<'\n';

outfile2 << "cd data" <<'\n';
outfile2 << "cd iso.trek" <<'\n';

outfile2 << '\n';
*/
//////


for (i=0; i<NOISO; i++)
{

/////
/*
outfile2 << "cd .." <<'\n';
outfile2 << "cd .." <<'\n';

outfile2 << "cd data" <<'\n';
outfile2 << "cd iso.trek" <<'\n';

outfile2 << '\n';
*/


/*
outfile2 << "cp is2_p019_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek ./../../utility/widecmd/is2_p019_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek";

outfile2 << '\n';


outfile2 << "cp is1_p019_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek ./../../utility/widecmd/is1_p019_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek";




outfile2 << '\n';

outfile2 << '\n';
//}

*/

/*
outfile2 << "cd .." <<'\n';
outfile2 << "cd .." <<'\n';

outfile2 << "cd utility" <<'\n';
outfile2 << "cd widecmd" <<'\n';
*/

//for (i=0; i<NOISO; i++)
//{

outfile2 << "echo is2_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek > vista.in" <<'\n' ;


outfile2 << "echo is2_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide > vista.out" <<'\n' ;

outfile2 << "./gowidecmdvista" <<'\n';


outfile2 << "cat is2_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide >> ./results/is2/is2_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide.all " <<'\n';

/*
outfile2 << "rm is2_p019_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek" <<'\n';
*/

outfile2 << "rm is2_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide" <<'\n';




outfile2 << '\n';


outfile2 << "echo is1_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek > standard.in" <<'\n' ;


outfile2 << "echo is1_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide > standard.out" <<'\n' ;

outfile2 << "./gowidecmdstandard" <<'\n';


outfile2 << "cat is1_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide >> ./results/is1/is1_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide.all " <<'\n';

/*
outfile2 << "rm is1_p019_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek" <<'\n';
*/

outfile2 << "rm is1_p"<<nameinuse[5]<<nameinuse[6]<<nameinuse[7]<<"_" ;

if (i*STEP+STARTISO<1000) {outfile2 << "0" ;}

outfile2 << i*STEP+STARTISO <<".trek.wide" <<'\n';




outfile2 << '\n';



}






outfile2.close();


  system("chmod u+x run.one");

  system("rm indexiso");



cout <<'\n';

cout <<"... all done !" <<"\n";

cout <<'\n';

return 0;
}

