////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : gowidecmdstandard
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//                    
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    gowidecmdstandard.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////



#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 
#include <stdlib.h> 

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>



#define NOCOLUMNS 1

#define PI 3.14159265


using namespace std;



int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[500];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,500,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,500,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
           
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(500,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(500,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}


int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////

int main()
{
  cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goWIDECMDSTANDARD' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";


  chdir("..");
  chdir("..");
  chdir("ini.files");

  double MASS;
  int VERBOSE;

  ifstream data0("cluster.ini");

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data0.peek()=='#') { data0.ignore(300,'\n');}

  data0 >> VERBOSE; data0.ignore(300,'\n');
  data0 >> MASS; data0.ignore(300,'\n');
  data0.ignore(300,'\n');

  data0.close();

  chdir("..");
  chdir("utility");
  chdir("widecmd");



//cout << MASS<<'\n';


double Wmax=0.75; //2.5, 5, 2, 0.5, 0.25
double Ymin=-13.;
double Ymax=17.; //12, 16
double Mminlim=0.15;//////0.15///// //0.7, 1, 0.15 , 0.35-->8.60, 0.60

double Wmaxir=0.25;
double Yminir=-14.;
double Ymaxir=12.; //12 10-->12


  /// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);


  srand((unsigned)time(0));

//outfile.setf(ios::fixed,ios::floatfield); 



  char nameinuse[18];
  char nameinuse2[23];


  ifstream fileinzero;
  fileinzero.open("standard.in");

  if (fileinzero.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }



  ifstream fileinone;
  fileinone.open("standard.out");

  if (fileinone.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }


fileinzero.width(19);
fileinzero >> nameinuse;
fileinzero.ignore(30,'\n');


fileinone.width(24);
fileinone >> nameinuse2;
fileinone.ignore(30,'\n');

cout << nameinuse <<"  "<< nameinuse2 <<'\n';


  int NOSTARS,NOSTARS2;

//  chdir(".."); // utility
//  chdir(".."); // MAIN
//  chdir("data"); // data

  NOSTARS=datalinescolumn("mass-gauss.txt",1);



  chdir(".."); // utility
  chdir(".."); // MAIN
  chdir("data"); // data
  chdir("iso.trek"); // iso.trek



  NOSTARS2=datalinescolumn(nameinuse,1);
 
  cout<<NOSTARS<<" "<<NOSTARS2<<'\n';  

ifstream filein;
filein.open(nameinuse);
if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein.peek()=='#') { filein.ignore(300,'\n');}


  chdir(".."); // data
  chdir(".."); // MAIN
  chdir("utility"); // utility
  chdir("widecmd"); // widecmd



//  chdir(".."); // MAIN
//  chdir("utility"); // utility
//  chdir("widecmd"); // widecmd

/*
double age,Mini,Mact,logL,logT;
double J,H,Ks;
double gauss;
double mass;
*/

 ofstream outfile(nameinuse2);

  if (outfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

outfile.setf(ios::fixed,ios::floatfield);

int i, k;




for (i=0;i<NOSTARS2;i++)
{


double age,Mini,Mact,logL,logT;
double U,B,V,R,I,J,H,K;
double gauss, gauss2, gauss3, gauss4, gauss5, gauss6, gauss7, gauss8;
double mass;


filein>> age;
filein>> Mini;

filein>> Mact;
filein>> logL;
filein>> logT;

filein>> U;
filein>> B;
filein>> V;
filein>> R;
filein>> I;
filein>> J;
filein>> H;
filein>> K;



filein.ignore(300,'\n');




//cout<<Mini<<'\n';


ifstream filein2;
filein2.open("mass-gauss.txt");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}


double sari;
//while (1)
for (k=0;k<NOSTARS;k++)
{
filein2>> mass;

filein2>> sari;
filein2>> sari;
filein2>> sari;
filein2>> sari;
filein2>> sari;

filein2>> gauss;
filein2>> gauss2;
filein2>> gauss3;
filein2>> gauss4;
filein2>> gauss5;
filein2>> gauss6;
filein2>> gauss7;
filein2>> gauss8;


filein2.ignore(300,'\n');

if (mass==Mini) 
{

//cout<<mass<<'\n';
//outfile<< setw(16)<< mass<<"  ";
break;
}


}

if (Mini>=Mminlim)
{

outfile.precision(2);

outfile << setw(6)<< age<<"   ";

outfile.precision(10);

outfile<<setw(16) << Mini<<"   "<<setw(16)<<Mact;

//outfile<<setw(16) << logL <<"   ";

//outfile<<setw(16) << logT <<"   ";


outfile<<setw(16) << U + (Wmax+log10(log10(MASS)))*(U-Ymin)/(Ymax-Ymin)*gauss <<"   ";

outfile<<setw(16) << B + (Wmax+log10(log10(MASS)))*(B-Ymin)/(Ymax-Ymin)*gauss2 <<"   ";


outfile<<setw(16) << V + (Wmax+log10(log10(MASS)))*(V-Ymin)/(Ymax-Ymin)*gauss3 <<"   ";

outfile<<setw(16) << R + (Wmax+log10(log10(MASS)))*(R-Ymin)/(Ymax-Ymin)*gauss4 <<"   ";

outfile<<setw(16) << I + (Wmax+log10(log10(MASS)))*(I-Ymin)/(Ymax-Ymin)*gauss5 <<"   ";

outfile<<setw(16) << J + (Wmaxir+log10(log10(MASS)))*(J-Yminir)/(Ymaxir-Yminir)*gauss6 <<"   ";

outfile<<setw(16) << H + (Wmaxir+log10(log10(MASS)))*(H-Yminir)/(Ymaxir-Yminir)*gauss7 <<"   ";

outfile<<setw(16) << K + (Wmaxir+log10(log10(MASS)))*(K-Yminir)/(Ymaxir-Yminir)*gauss8 <<"   ";




outfile<<'\n';
} //Mminlim


} // i loop

cout <<"... all done !" <<'\n';

cout <<'\n';



 return 0;

}

